// checks whether there would be an entry in the collection listing
// (depends on edit- or view-mode)
function collectionIsEmpty (objarray)
{
  if (typeof objarray == "object")
  {
    for (var i in objarray)
    {
      if (typeof objarray[i] == "object")
      {
        if (top.editmode || ((objarray[i].PH != "FullCollectionHead") &&
          (objarray[i].PH != "CollectionHead") &&
          (objarray[i].PH != "Hidden")))
          return false;
      }
    }
  }
  return true;
}

// returns the HTML for the info-icon and the link
// to the edit/view-attributes dialog 
function getInfoIcon (obj)
{
  var ret = '<A HREF="#" ';
  var act = (top.editmode && obj.A=="WRITE_ACCESS" && obj.CT!="ServColl") ? "dialog.editattributes":"dialog.attributes";
  ret += 'ONCLICK="opDlg(\'/' + obj.G + ';internal&action=' + act + '.action\',\'dialogs\');return false;"';
  ret += '>';
  ret += '<IMG BORDER=0 ALT="info" SRC="';
  if (obj.HWAT=="Configuration")
    ret += "/icons/inforedc2.gif";
  else if (obj.HWC && obj.HWC!="undefined")
    ret += "/icons/infoblackc2.gif";
  else
    ret += "/icons/infosmall2.gif";
  ret += ';internal&inline=true" WIDTH="15" HEIGHT="16"></A>';
  return ret;
}

// returns the HTML for the checkbox and the hidden fields 
// for the edit-mode
function getCheckbox (obj)
{
  var ret = "";
  ret += '<INPUT TYPE=CHECKBOX NAME="initname'+obj.ST+'" VALUE="'+obj.G+'">';
  ret += '<INPUT TYPE=HIDDEN NAME="dummy" VALUE="'+obj.G+'">';
  ret += '<INPUT TYPE=HIDDEN NAME="HWTITLE' + obj.G + '" VALUE="' + obj.T + '">';
  return ret;
}

// writes the HTML for the link to the drop-down menu
// on the leftmost column in view-mode
function writeIconWithMenu (params)
{
  var p = params || {};
  p.ma=p.ma||"r";
  p.yp=p.yp||"b";
  p.xp=p.xp||"r";
  p.obj=p.obj||"";
  p.oname=p.openername||p.menuname;

  if (navigator.appName!="Netscape")
    document.write('<SPAN ID="'+p.oname+'">');
  document.writeln("<A BORDER='0' HREF='#' onClick=\"openMenu(-1,-1,{obj:'"+p.obj+"',mname:'"+p.menuname+"',oname:'"+p.oname+"',yp:'b',xp:'"+p.xp+"',ma:'"+p.ma+"',h:false});return false;\">")
  document.write('<img');
  if (navigator.appName=="Netscape")
    document.write(' name="',p.oname,'"');
  document.writeln(' src="',p.imgsrc,'" border="0"></a>');
  if (navigator.appName!="Netscape")
    document.write('</SPAN>');
}

// navigates to the object id, and adds the path in the tree
// to get there if nopath!=true
function ld (id, nopath) 
{
  if (typeof(nopath)!="boolean") nopath = false;
        // check whether the current path is valid
  var found = top.cs_checkPath(top.req, top.tv, top.tvcfg.path);
  if (found)
  {
          // if current path is valid, add this object's index to the path
    top.tvcfg.path[top.tvcfg.path.length] = getIndex(id, top.listingobjs);
  }
  else
  {
          // if current path is not valid (should not happen), the object
          // will be looked up in the tree-structure
    var out = top.cs_getPath(id,top.tv,[]);
    top.tvcfg.path = out.path;
  }
  var href = "/"+id;
        // add path-information to url
  if (!nopath) href += ";path="+escape(top.tvcfg.path.toString());
  top.frames["HW_Mainframe"].location.href = href;
  return false;
}


// sortorder-functions: used to perform sorting of the listing on cs.

// collections are ranked above other objects in the listing
// compares whether on of the objects is of documenttype collection
function so_isCollection (a, b)
{
  if ((getTypeIndex(a) == 1) && (getTypeIndex(b) != 1))
    return -1;
  if ((getTypeIndex(b) == 1) && (getTypeIndex(a) != 1))
    return 1;
  return 0;
}

// compares value a to value b
function so_comp (a, b)
{
  if (a > b)
    return 1;
  if (b > a)
    return -1;
  
  return 0;
}

// compares the title of a and b
function so_title (a, b)
{
  var mya = unescape(a.T).toLowerCase();
  var myb = unescape(b.T).toLowerCase();
  
  return so_comp(mya, myb);
}

// compares the title of a and b in ascending order
function so_title_asc (a, b)
{
  var iscoll = so_isCollection(a,b);
  if (iscoll != 0)
    return iscoll;

  return so_title(a,b);
}

// compares the title of a and b in descending order
function so_title_desc (a, b)
{
  var iscoll = so_isCollection(a,b);
  if (iscoll != 0)
    return iscoll;

  return so_title(a,b)*(-1);
}

// compares the author of a and b in ascending order
function so_author_asc (a, b)
{
  var iscoll = so_isCollection(a,b);
  if (iscoll != 0)
    return iscoll;

  var ret = so_comp(unescape(a.AU).toLowerCase(),unescape(b.AU).toLowerCase());
  if (ret != 0)
    return ret;

  return (so_title(a, b));
}

// compares the author of a and b in descending order
function so_author_desc (a, b)
{
  var iscoll = so_isCollection(a,b);
  if (iscoll != 0)
    return iscoll;

  var ret = so_comp(unescape(a.AU).toLowerCase(),unescape(b.AU).toLowerCase());
  if (ret != 0)
    return ret*(-1);

  return (so_title(a, b));
}

// compares the modification times of a and b in ascending order
function so_time_asc (a, b)
{
  var iscoll = so_isCollection(a,b);
  if (iscoll != 0)
    return iscoll;

  var ret = so_comp(unescape(a.TM),unescape(b.TM));
  if (ret != 0)
    return ret;

  return (so_title(a, b));
}

// compares the modification times of a and b in descending order
function so_time_desc (a, b)
{
  var iscoll = so_isCollection(a,b);
  if (iscoll != 0)
    return iscoll;

  var ret = so_comp(unescape(a.TM),unescape(b.TM));
  if (ret != 0)
    return ret*(-1);

  return (so_title(a, b));
}

// this array defines the sortorder for type-sorting
var so_DOCTYPES = {'collection':1,
                   'text':10,
                   'image':12,
                   'film':14,
                   'audio':16,
                   'scene':18,
                   'PostScript':20,
                   'generic':22,
                   'annotation':24,
                   'remote':26};

// defines the the sortorder for objects of type collection
var so_COLLTYPES = {'Collection':1,
                    'Cluster':3,
                    'Sequence':1,
                    'MultiCluster':3,
                    'AlternativeCluster':3};

// defines the sortorder for objects of type collection that 
// are not used like regular collections
var so_SPECIALTYPES = {'DForum':1,
                       'DCCollection':1,
                       'DCCollection-forceshow':1,
                       'DCObject': 5};

// returns an index that makes a type-comparison possible
function getTypeIndex (a)
{
  if (typeof so_DOCTYPES[a.DT] != "undefined")
  {
    if (so_DOCTYPES[a.DT] == 1)
    {
      if (a.DCO == "yes")
        return so_SPECIALTYPES['DCObject'];
      if (a.DCFS == "true")
        return so_SPECIALTYPES['DCCollection-forceshow'];
      if (a.DCI == "yes")
        return so_SPECIALTYPES['DCCollection'];

      if (a.DF == "yes")
        return so_SPECIALTYPES['DForum'];
        
      if (a.CT && typeof so_COLLTYPES[a.CT] != "undefined")
        return so_COLLTYPES[a.CT];
    }
    return so_DOCTYPES[a.DT];
  }
  return 30;
}

// compares the types of objects a and b in ascending order
function so_type_asc (a, b)
{
  var ret = so_comp(getTypeIndex(a),getTypeIndex(b));
  if (ret != 0)
    return ret;
  
  return (so_title(a, b));
}

// compares the types of objects a and b in descending order
function so_type_desc (a, b)
{
  var ret = so_comp(getTypeIndex(a),getTypeIndex(b));
  if (ret != 0)
    return ret*(-1);

  return (so_title(a, b));
}

// performs the sorting when clicking on the table header bar
function sort (order)
{
  if (typeof order == "string")
  {
    top.sortorder = order;
    self.location.replace(self.location.href);
  }
  return false;
}

// determines whether the current sortorder is ascending or descending
function getMulti (sortorder)
{
  if (typeof sortorder != "string")
    return 0;

  if (sortorder.indexOf("asc") != -1) return 1;
  if (sortorder.indexOf("desc") != -1) return -1;
  return 0;
}

// returns the sort-function according to the current sortorder
function getSortFunction (sortorder)
{
  var stype = getSortType(sortorder);
  var multi = getMulti(sortorder);
  var func;
  if (stype == "type")
    if (multi == 1)
      func = so_type_asc;
    else
      func = so_type_desc;
  if (stype == "title")
    if (multi == 1)
      func = so_title_asc;
    else
      func = so_title_desc;
  if (stype == "time")
    if (multi == 1)
      func = so_time_asc;
    else
      func = so_time_desc;
  if (stype == "author")
    if (multi == 1)
      func = so_author_asc;
    else
      func = so_author_desc;
  return func;
}

// extracts the current sort type 
function getSortType (sortorder)
{
  if (typeof sortorder == "string")
    return sortorder.replace(/asc/,"").replace(/desc/,"");
  return "";
}

// returns the index of the object id in the object array
function getIndex (id, objarr)
{
  if (typeof objarr == "object")
  {
    for (var i=0; i<objarr.length; i++)
    {
      if ((typeof(objarr[i])=="object") && ((id == objarr[i].N) || (id == objarr[i].G))) 
        return i;
    }
  }
  return -1;
}

// used to access document class objects
function openDC (id, onclick, path)
{
  if (typeof path != "object")
  {
    var out = top.cs_getPath(id,top.tv,[]);
    var path = out.path;
  }
        // set the path
  top.tvcfg.path = path;
  var tonclick = unescape(onclick);
  tonclick = tonclick.substring(0,tonclick.indexOf("return"));
        // perform original onclick-action
  eval(tonclick);
  return false;
}


function cslisting ()
{
        // check whether the language related information is available
  if (typeof top.listing != 'object') 
    top.listing = {};

        // write title
  var obj = {G: top.req.goid, A: top.req.A, CT: top.req.CT, HWAT: top.req.HWAT, HWC: top.req.HWC};
  document.write('<A NAME="hw_cur"><H2 CLASS="colltitle">');
  document.write(getInfoIcon(obj));
  document.writeln('&nbsp;<IMG SRC="/wavemaster.internal/icons/coll_open.gif">&nbsp;' + unescape(top.req.title) + '</H2></A>');

        // extract sortorder information
  if (typeof top.sortorder != "string") 
  {
    top.sortorder = "asctitle";
  }
  var stype = getSortType(top.sortorder);
  var multi = getMulti(top.sortorder);
  var nosortorder = ((typeof(top.req.SortOrder)=="undefined") || (top.req.SortOrder=="undefined"));

  if (typeof top.listingobjs == "object")
  {
          // write hidden fields for edit-mode
	if (top.editmode)
	{
      document.writeln('<FORM name="bodyform" method=POST action="">');
      document.writeln('<INPUT TYPE="HIDDEN" NAME="new1" VALUE="">');
      document.writeln('<INPUT TYPE="HIDDEN" NAME="new2" VALUE="">');
      document.writeln('<INPUT TYPE="HIDDEN" NAME="PLACE_MOVECOPYOBJECTDESTINATION" VALUE="" >');
	}

	document.writeln('<TABLE CELLPADDING="1" CELLSPACING="0" BORDER="0" WIDTH="100%">');
    
          // write the listing-header
    document.writeln('<TR>');
          // write column for drop-down menu
    if (top.editmode)
    {
      document.writeln('<TD CLASS="collheader">&nbsp;</TD>');
    }

    document.writeln('<TD VALIGN="BOTTOM" ALIGN="CENTER" CLASS="collheader">&nbsp;</TD>');
          // write column for info-icon
    document.writeln('<TD VALIGN="BOTTOM" ALIGN="CENTER" CLASS="collheader">&nbsp;</TD>');

          // write column for object icon
    document.write('<TD ALIGN="CENTER" CLASS="collheader" VALIGN="BOTTOM">');
          // write sort-link
    if (nosortorder)
    { // sort link only when collection has no defined sortorder
      document.write('<A HREF="#" ONCLICK="sort(\'');
      if (stype!="type")  
        document.write('asctype');
      else
        if (multi==-1)
          document.write('asctype');
        else
          document.write('desctype');
      document.write('\'); return false;" CLASS="collheader">');

            // write the HTML for the up/down arrow
    if (stype=="type")
      if (multi==-1)
        document.write('<IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/sortup.gif" WIDTH=16 HEIGHT=16 BORDER=0>');
      else
        document.write('<IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/sortdown.gif" WIDTH=16 HEIGHT=16 BORDER=0>');
    }
    document.write(top.listing.type || "Type");
    if (nosortorder) document.write('</A>');
    document.write('</TD>');

          // write column for title
    document.write('<TD ALIGN="LEFT" CLASS="collheader" VALIGN="BOTTOM">');
          // write sort-link
    if (nosortorder) 
    {  // sort link only when collection has no defined sortorder
      document.write('<A HREF="#" ONCLICK="sort(\'');
      if (stype!="title")
        document.write('asctitle');
      else
        if (multi==-1)
          document.write('asctitle');
        else
          document.write('desctitle');
      document.write('\'); return false;" CLASS="collheader">');
      
            // write the HTML for the up/down arrow
      if (stype=="title")
        if (multi==-1)
          document.write('<IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/sortup.gif" WIDTH=16 HEIGHT=16 BORDER=0>');
        else
          document.write('<IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/sortdown.gif" WIDTH=16 HEIGHT=16 BORDER=0>');
    }
    document.write(top.listing.title || "Title");
    if (nosortorder) document.write('</A>');
    document.write('</TD>');      

          // write column for Modification Time
    document.write('<TD ALIGN="LEFT" CLASS="collheader" VALIGN="BOTTOM">');
          // write sort-link
    if (nosortorder) 
    {  // sort link only when collection has no defined sortorder
      document.write('<A HREF="#" ONCLICK="sort(\'');
      if (stype!="time")
        document.write('asctime');
      else
        if (multi==-1)
          document.write('asctime');
        else
          document.write('desctime');
      document.write('\'); return false;" CLASS="collheader">');
      
            // write the HTML for the up/down arrow
      if (stype=="time")
        if (multi==-1)
          document.write('<IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/sortup.gif" WIDTH=16 HEIGHT=16 BORDER=0>');
        else
          document.write('<IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/sortdown.gif" WIDTH=16 HEIGHT=16 BORDER=0>');
    }
    document.write(top.listing.modified || "Modified");
    if (nosortorder) document.write('</A>');
    document.write('</TD>');

          // top.listing.friendlyname determines whether the netmeeting
          // link will be provided
    if (top.listing.friendlyname)
    {
      if ((typeof(top.listing.netmeeting)!="undefined") && (top.listing.netmeeting!="no"))
        document.write('<TD CLASS="collheader">&nbsp;</TD>');  // hosts the netmeeting image
    }

          // write column for owner
    document.write('<TD ALIGN="LEFT" CLASS="collheader" VALIGN="BOTTOM">');
          // write sort-link
    if (nosortorder)
    {  // sort link only when collection has no defined sortorder
      document.write('<A HREF="#" ONCLICK="sort(\'');
      if (stype!="author")
        document.write('ascauthor');
      else
        if (multi==-1)
          document.write('ascauthor');
        else
          document.write('descauthor');
      document.write('\'); return false;" CLASS="collheader">');
            // write the HTML for the up/down arrow
      if (stype=="author")
        if (multi==-1)
          document.write('<IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/sortup.gif" WIDTH=16 HEIGHT=16 BORDER=0>');
        else
          document.write('<IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/sortdown.gif" WIDTH=16 HEIGHT=16 BORDER=0>');
    }
    document.write(top.listing.owner || "Owner");
    if (nosortorder) document.write('</A>');
    document.write('</TD>');

          // write column for size
    document.write('<TD VALIGN="BOTTOM" ALIGN="RIGHT"  CLASS="collheader">');
    document.writeln((top.listing.size || "Size") + '</TD>');

    document.writeln('</TR>'); // end table header

          // copy current listing objects, otherwise sort-actions would
          // effect the treeview in the navigation frame
    var objarr = top.listingobjs.slice(0);

          // sort the listing according to the chosen sortorder
    if ((typeof top.sortorder == "string") && (nosortorder))
      objarr.sort(getSortFunction(top.sortorder));

          // write notification if collection is empty
    if (collectionIsEmpty(top.listingobjs))
    {
      if (top.editmode) 
        var span = 9;
      else
        var span = 8;
      
      document.writeln('<TR><TD colspan="' + span + '"><I>' + (top.listing.empty || 'The collection is empty') + '</I></TD></TR>');
    }

          // hidden objects and collectionheads should be displayed
          // if collection is a query
    var showHidden = (!top.editmode && (top.req.COT == "Query"));
    var showCollHeads = (!top.editmode && (top.req.COT == "Query"));

          // used by drop-down menu
    var openercount = 0;

          // start displaying listing entries
    for (var i in objarr)
    {
      if (typeof objarr[i] == "object" && (!(objarr[i].ADD && objarr[i].ADD.indexOf("skiplisting")!=-1)))
      {
        var curobj = objarr[i];
        if ((top.editmode) || 
          (((curobj.PH != "Hidden") || (showHidden)) &&
            ((curobj.PH != "CollectionHead") || (showCollHeads)) &&
            (curobj.PH != "FullCollectionHead")))
        {
          document.writeln('<TR>');
          
                // write checkbox
          if (top.editmode)
          {
            document.write('<TD WIDTH="20" VALIGN="top" ALIGN="CENTER">');
            document.write(getCheckbox(curobj));
            document.writeln('</TD>');
          }

                // write drop-down menu
          if (curobj.DT != 'collection' && curobj.DT != 'Image' && !top.editmode && typeof objmenuname!="undefined") 
          {
            document.writeln('<TD ALIGN="CENTER" VALIGN="top">');
            writeIconWithMenu({ma:"l",xp:"l",imgsrc:"/icons/openmenu.gif;internal&inline=true",openername:objmenuname+openercount,menuname:objmenuname,obj:curobj.G});
            openercount++;
            document.write('</TD>');
          }
          else 
          {
            document.writeln('<TD ALIGN="CENTER" VALIGN="top">');
            document.write('&nbsp;');
            document.write('</TD>');
          }

                // write attributes-icon
          document.write('<TD ALIGN="CENTER" VALIGN="top">');
          document.write(getInfoIcon(curobj));
          document.writeln('&nbsp;</TD>');

                // compute link for object icon and title
          var url = curobj.U;
          if (url && ((url.search(/onclick/i)!=-1) || (url.search(/;internal&/i)!=-1)) &&
            !(top.editmode && curobj.DF))
          { // handling if object is not a regular one
            var lstr = "<A HREF=\"";
            if (url.lastIndexOf('"') != (url.length-1))
              url += '\"';
            
            if (curobj.DCI=="yes")
            { // handling of document class
              var path = top.tvcfg.path.concat(getIndex(curobj.G, top.listingobjs));
              lstr += top.cs_getDCUrl((curobj.N || curobj.G),url, path);
            }
            else
            {
              lstr += url;

              if (url.search(/;internal&/i)!=-1)
              {
                lstr = lstr.substring(0,lstr.length-1);
                var path = top.tvcfg.path.concat(getIndex(curobj.G, top.listingobjs));
                if (typeof path == "object")
                  lstr += '&path='+escape(path.toString())+'"';
              }  
            }
          }
          else
          {
                  // handling of standard objects
            var lstr = '<A HREF="/' + (curobj.N || curobj.G) + '" ';
            lstr += 'ONCLICK="ld(\''+(curobj.N || curobj.G)+'\','+((curobj.ADD=="skiptree")?true:false)+'); return false;"';
          }
          lstr += ' CLASS="collentry">';

                // write object icon
          document.writeln('<TD ALIGN="CENTER" VALIGN="top">');
          document.write(lstr);
          document.write("<IMG SRC=\"");
          if (curobj.I)  // standard icon
          {
            document.write("/icons/" + curobj.I);
          }
          else
          {
            if (curobj.IC) // special icon
            {
              document.write(curobj.IC);
            }
          }
          document.writeln(';internal&inline=true" BORDER="0"></A></TD>');


                // write link to the object
          document.writeln('<TD ALIGN="LEFT" VALIGN="top">');
          document.write(lstr);
          document.write(unescape(curobj.T));
          document.write('</A>');
          
          document.write('&nbsp;');
                // write new, updated - information
          if (curobj.NM)
            document.write('<FONT COLOR="red"><I><SPAN class=Update>'+curobj.NM+'</SPAN></I></FONT>');
          
                // version information
          if (curobj.VM)
            document.write('<SPAN CLASS="collattributes"><I>&nbsp;'+curobj.VM+'</I></SPAN>');
          document.writeln('</TD>');

          
                // write modification time
          document.write('<TD ALIGN="LEFT" WIDTH="125" VALIGN="top" CLASS="collattributes" nowrap>');
          document.write('<NOBR>');
          document.write(transformDate(curobj.TM,HWDate,HW_UI_Date.full,false));
          document.write('&nbsp;</NOBR>');
          document.writeln('</TD>');

                // write link for netmeeting
                // top.listing.friendlyname determines whether the netmeeting
                // link will be provided
          if (top.listing.friendlyname)
          {
            if ((typeof(top.listing.netmeeting)!="undefined") && (top.listing.netmeeting!="no"))
            {
              document.writeln('<TD ALIGN="LEFT" VALIGN="top" CLASS="collattributes">');
//                if ((curobj.NETM == 'yes') && 
//                  (typeof(curobj.EM) == 'string') && (curobj.EM!=''))
              if ((typeof(curobj.EM) == 'string') && (curobj.EM!=''))
              {
                document.write('<A HREF="/' + curobj.G + ';internal&action=netmeeting.action.cnf">');
                document.write('<IMG BORDER="0" ALT="' + ((typeof(top.listing.netmeeting) == "string") ? top.listing.netmeeting.replace(/-author-/,unescape(curobj.AU)) : "") + '" SRC="/wavemaster.internal/v1.0/uistyle/icons/conference.gif" ');
                document.write('WIDTH="15" HEIGHT="16"></A>');
              }
              else document.write('&nbsp;');
              document.writeln('</TD>');
            }
          }


                // write Owner
          document.writeln('<TD ALIGN="LEFT" VALIGN="top" CLASS="collattributes">');
          document.writeln('<NOBR>');
                // top.listing.friendlyname determines whether a mailto-link
                // will be attached to the owner-name or a link to a dialog
                // that presents a business-card
          if (top.listing.friendlyname)
          {
            if (curobj.EM)
              document.write('<A HREF="mailto:' + curobj.EM +'"  CLASS="collattributes">');
          }
          else
          {
            document.write('<A HREF="#" ONCLICK="opDlg(\'/' + curobj.G + ';internal&action=dialog.businesscard.action\',\'dialogs\');return false;" CLASS="collattributes">');
          }
          document.write((curobj.AU) ? unescape(curobj.AU) : "&nbsp;");
          if ((!top.listing.friendlyname) || (curobj.EM))
            document.write('</A>');
          document.writeln('</NOBR>');
          document.writeln('</TD>');
          

                // write size for documents and number of subdocuments 
                // for collections
          document.write('<TD ALIGN="RIGHT" VALIGN="top" CLASS="collattributes">');
          document.write('&nbsp;');
          if (curobj.S)
            document.write("&nbsp;" + curobj.S.replace(/\s/gi,"&nbsp;"));
          else
          {
            if (curobj.SD)
            {
              document.write(curobj.SD,"&nbsp;",(top.listing.docs || "docs"));
            }
          }
          document.write('</TD>');
          document.writeln('</TR>');


                // write description if one exists
          if (curobj.DES)
          {
            var indent = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
            if (top.editmode)
              document.write('<TR><TD COLSPAN="4">');
            else
              document.write('<TR><TD COLSPAN="3">');
            document.writeln('&nbsp;</TD><TD COLSPAN="5" VALIGN="top" CLASS="colldescr">' + indent + unescape(curobj.DES) + '</TD></TR>');
          }
        }
      }
    }
  }
  document.writeln('</TABLE>');
  
  if (top.editmode)
  {
    document.writeln('</FORM>');
  }
}
