// -------------------------------------------------------------------------
// The following hw_dlgStyle object is only a fallback in case the current
// dialog style (default is dstyle (=DDC) !) style doesn't define "inborder", etc...
// inborder: if true, the caption is written "into" the borderline, otherwise above
// ignoreDlgCap: if true, dlg_spec.caption is ignored (--> No caption is written !).
// ignoreDlgDescr: if true, dlg_spec.descr is ignored (--> No description is written !).
// ignoreDlgNecessary: if true, no "* indicates a required field" text is added to the Description.
hw_dlgStyle = {
  inborder: false,
  ignoreDlgCap: false,
  ignoreDlgDescr: false,
  ignoreDlgNecessary : false  };

var global_confScriptInserted = false;
var global_reqAttr = false;
// -------------------------------------------------------------------------

// *******************************************************************
//  returns the caption of an spec obj.
//  if obj.caption is defined and the text for the language is
//  available it is returned. Otherwise obj.name (if defined) or
//  obj.def is returned. if nothing is defined 'undefined' will be
//  returned
// *******************************************************************
function getCaption(obj,colon)
{
  function withColon(cap)
  {
    //if last character isn't a ":" and caption isn't empty
    if (colon && cap[cap.length-1]!=":" && cap.search(/\S/)!=-1)
      return cap+":";
    else
      return cap;
  }

  if (obj.caption)
  {
    if (typeof obj.caption == "string") return withColon(obj.caption);
    var a_lang = client.languages.split(' ');
    for (x in a_lang) {
      if (typeof obj.caption[a_lang[x]] != 'undefined')
        return withColon(obj.caption[a_lang[x]]);
    }
    if (obj.caption["en"])
      return withColon(obj.caption["en"]);
    else if (obj.caption[0])
      return withColon(obj.caption[0]);
  }

  return obj.name?withColon(obj.name):obj.def;
}

// *******************************************************************
// writes the scripts to confirm input fields (for required, integer/float,
// time, etc....basically all input elements that need a check for 
// correct user-input before submitting the form...)
// *******************************************************************
function HW_DC_incConfirmScripts(pars)
{
  function printParams(params)
  {
    for (var i=0; i<params.paramspecs.length; i++)
    {
      var parI=params.paramspecs[i];
      if (parI.type=="HW_API_Content")
        HW_formIsMultiPart=true;

      if (parI.type=="reqAttr")
      {
        global_reqAttr = HW_DC_getRequiredAttributes();
        if (typeof global_reqAttr != "undefined")
          printParams({paramspecs:global_reqAttr}); //write SpecArr for required attributes
      }

      if (!parI.type) parI.type='string'; //default is 'string'
      if (!parI.name && parI.type=="wizard") parI.name=parI.subtype; //subtype is name-fallback for wizard
      if (parI.name && parI.inout!="out" && (parI.necessity=="required" || parI.range || parI.type=="integer" || parI.type=="float" || parI.type=="time" || parI.type=="HW_API_LanguageString" || (parI.type=="checkbox" && parI.subtype != "simple") || parI.type=="boolean"))
      {
        if (!global_confScriptInserted) {
          global_confScriptInserted=true;
          writeln("<SCRIPT>\n<!--");
          writeln("var SpecArray=[];");
        }
        write("SpecArray['"+((params.prefix)?params.prefix:'')+parI.name+"']={");
        write("caption:'"+getCaption(parI,1)+"',type:'"+parI.type+"'");

        if (typeof parI.range != "undefined")
        {
          var parIR=parI.range;
          if (typeof parIR.lower != "undefined")
            write(",lower:"+parIR.lower);
          if (typeof parIR.upper != "undefined")
            write(",upper:"+parIR.upper);
          if (parIR.not) {
            write(",not:");
            writeArray(parIR.not,"",true);
            if (parIR.nottext)
              write(",nottext:'"+parIR.nottext+"'");
          }
        }
        if (typeof parI.necessity != "undefined")
        {
          write (",necessity:'"+parI.necessity+"'");
          if (parI.necessity=="required") has_required=true;
        }
        if (parI.type=="checkbox" || parI.type=="boolean")
        {
          write(",checkedValue:'"+((typeof parI.checkedValue != "undefined")?parI.checkedValue:"true")+"'");
          write(",notcheckedValue:'"+((typeof parI.notcheckedValue != "undefined")?parI.notcheckedValue:"false")+"'");
        }
        writeln("};");
      }
    }
  }

  if (typeof pars == 'undefined') return false;
  var has_required=false;

  for (var x=0;x<pars.length;x++)
    for (var y=0;y<pars[x].boxes.length; y++)
      printParams(pars[x].boxes[y]);

  if (global_confScriptInserted) {
  // ----------------------------------------------------------------------------
  // insert the function to verify a text input
  // ----------------------------------------------------------------------------
  writeln("function HW_DC_confirmInput(obj,show_alert) {");
  //checks if type is correct, if "required" values aren't empty and if values are in correct range
  writeln("  function checkNot() {");
  writeln("    for (var x=0;x<specs.not.length;x++)");
  writeln("      if (specs.not[x] == obj.value) return false;");
  writeln("    return true");
  writeln("  }");
  writeln("  function checkInput() {");
  writeln("   if (typeof obj.options=='object' && specs.necessity=='required' && obj.options[obj.selectedIndex].value.search(/\\S/)==-1)");
  writeln("     return 'required';");
  writeln("   else if (typeof obj.value=='string' && obj.value.search(/\\S/)==-1) {");
  writeln("     obj.value='';");
  writeln("     if (specs.necessity=='required') return 'required';");
  writeln("   }");
  writeln("   if (specs.type=='integer' && obj.value != parseInt(obj.value) ||");
  writeln("       specs.type=='float' && obj.value != parseFloat(obj.value)) return 'type';");
  writeln("   if ((typeof specs.lower != 'undefined' && obj.value<specs.lower) ||");
  writeln("      (typeof specs.upper != 'undefined' && obj.value>specs.upper)) return 'range';");
  writeln("   if (typeof specs.not != 'undefined' && !checkNot()) return 'not';");
  writeln("   if (specs.type=='time' && !chkDateInForm(obj,true,false,{})) return 'time';");
  writeln("   return ''"); //no error !
  writeln("  }")

  writeln("  var specs = SpecArray[obj.name];");
  writeln("  if (typeof specs == 'undefined' || specs.type == 'checkbox' || specs.type == 'boolean')");
  writeln("    return true;");
  writeln("  var err=checkInput()");
  writeln("  if (err) {");
  writeln("    if (show_alert) {");
  writeln("      if (err=='required') alert('"+lrc("ddAleMsg1","lib",{name:"'+specs.caption+'"},"Please enter a value for:\\n\\n%name%\\n\\nThis value is required!")+"');");
  writeln("      else if (err=='type') alert('"+lrc("ddAleMsg2","lib",{name:"'+specs.caption+'",type:"'+specs.type+'"},"Please enter a correct value for:\\n\\n%name%\\n\\nThe entered value is not valid!\\nA value of the type \"%type%\" is expected.")+"');");
  writeln("      else if (err=='range') alert('"+lrc("ddAleMsg3","lib",{name:"'+specs.caption+'",value:"'+obj.value+'",loRange:"'+((typeof specs.lower!='undefined') ? specs.lower : '~')+'",hiRange:"'+((typeof specs.upper != 'undefined') ? specs.upper : '~')"},"Please enter a correct value for:\\n\\n%name%\\n\\nThe entered value %value% is not in defined range: %loRange% to %hiRange%")+");");
  writeln("      else if (err=='not')");
  writeln("        if (specs.nottext) alert(specs.nottext);");
  writeln("        else alert('"+lrc("ccAleMsg2","lib","Append a Name to the suggested prefix")+" !"+"')");
  writeln("    }");
  writeln("    return false;");
  writeln("  }");
  writeln("  return true;");
  writeln("}");
  // ----------------------------------------------------------------------------
  // insert function to change set the checkbox value in the hidden field
  // associated to the checkbox. So the correct boolean value of the checkbox
  // can be set in the server.
  // and concats the language string to the value string of an language
  // dependant string.
  // ----------------------------------------------------------------------------
  writeln("function changeElements(obj){");
  // for bool values set the shadow field correctly
  writeln("  for (var i=0; i < obj.elements.length; i++) {");
  writeln("    if (obj.elements[i].type=='checkbox'){");
  writeln("      var sf = obj.elements[obj.elements[i].name+'_s'];");
  writeln("      if (typeof sf!='undefined'){");
  writeln("        var specs = SpecArray[obj.elements[i].name];");
  writeln("        sf.value = obj.elements[i].checked?specs.checkedValue:specs.notcheckedValue;");
  writeln("        sf.name = obj.elements[i].name;");
  writeln("        obj.elements[i].name = '';");
  writeln("      }");
  writeln("    } else");
  writeln("    if (obj.elements[i].type=='select-one') {");
  writeln("     var namind=obj.elements[i].name.indexOf('_ddlang');");
  writeln("     if (namind!=-1){");
  writeln("      var ttitle=obj.elements[i-1].value;");
  writeln("       obj.elements[i+1].value = obj.elements[i].options[obj.elements[i].selectedIndex].value+':'+ttitle;");
  writeln("      obj.elements[i-1].name='';obj.elements[i].name='';");
  writeln("      obj.elements[i+1].name=ttitle?obj.elements[i+1].name.substring(0,namind):''");
  writeln("}}}");
  writeln("  for (var x in SpecArray)\nif (SpecArray[x].type=='time') convDateInForm(obj[x],{TransformToGMT:1})");
  writeln("}");

  // ----------------------------------------------------------------------------
  // insert the function to verify the input before submitting.
  // returns true if submitting is possible (e.g. all values correct an available).
  // ----------------------------------------------------------------------------
  writeln("function HW_DC_verifySubmit(obj) {");
  writeln("  for (var i=0; i < obj.elements.length; i++) {");
  writeln("    if (typeof obj.elements[i].name != 'undefined' && !HW_DC_confirmInput(obj.elements[i],true) ) {");
  writeln("      if (typeof obj.elements[i].select!='undefined') obj.elements[i].select();");
  writeln("      obj.elements[i].focus();");
  writeln("      currentField = obj.elements[i];");
  writeln("      return false;");
  writeln("    }");
  writeln("  }");
  writeln("  changeElements(obj);");
  writeln("  return true;");
  writeln("}");
  writeln("// -->\n</SCRIPT>");
  }
  return has_required;
}

function write_topofBox(dlg_spec,cap)
{
  var inbord=dlg_spec.style.inborder || hw_dlgStyle.inborder;
  if (cap && !inbord)
    writeln('<TR><TD COLSPAN="3"><BR><SPAN class=CaptionC>'+cap+'</SPAN></TD></TR>');
  var boxcap=typeof cap=="undefined"?dlg_spec.caption:cap;
  write(tableRowTopLeft(boxcap,dlg_spec.style,{onlyRow:true,colspan:"2",inborder:inbord}));
}

// *******************************************************************
// creates the header (title, description,...) of a dialog
// *******************************************************************
function HW_DC_dialogHeader(dlg_spec,param_specs)
{
  var parspecs=param_specs || [];
  HW_dialogHeader(dlg_spec,[{boxes:parspecs}]);
  write_topofBox(dlg_spec,dlg_spec.subcaption);
}

function HW_dialogHeader(dlg_spec,params)
{
  //cuts "..." of in Caption of "DocuClasses default dialogs"
  if (typeof dlg_spec.caption != "undefined")
    dlg_spec.caption=dlg_spec.caption.replace(/\.\.\.$/,"");

  HW_formIsMultiPart=dlg_spec.formIsMultiPart || false;
  if (!dlg_spec.style)
    dlg_spec.style = dstyle;
  if (!dlg_spec.formname)
    dlg_spec.formname="f1";
  if (!dlg_spec.script) dlg_spec.script=dlg_spec.confirmcreatescript;
  if (!dlg_spec.onsubmit) dlg_spec.onsubmit=dlg_spec.confirmcreate;
  writeln("<HTML>");

  // ----------- HEAD BEGIN ----------------
  write("<HEAD><TITLE>");
  if (typeof dlg_spec.caption != "undefined")
    write(dlg_spec.caption);
  writeln("</TITLE>");

  write(dialogStyles(dlg_spec.style));

  if (dlg_spec.opdlgfunc)
    write(openDialogFunction({}));
  if (dlg_spec.datefunctions)
    writeln(place("get_date_config"));
  if (dlg_spec.moreless || dlg_spec.moreless_scriptonly)
    writeln(place("moreless_scripts"));
  if (dlg_spec.setexpire)
    writeln(place("set_expire_now"));
  
  if (dlg_spec.macro)
    if (dlg_spec.macro.constructor == Array)
    {
      for (var x=0;x<dlg_spec.macro.length;x++)
        hw_writePLACEWithError(dlg_spec.macro[x]);
    }
    else
      hw_writePLACEWithError(dlg_spec.macro); //single macro

  if (dlg_spec.script)
  {
    writeln('<SCRIPT>\n<!--\n');
    if (typeof dlg_spec.script == "function")
      writeln(dlg_spec.script.toString());
    else if (typeof dlg_spec.script == "string")
      writeln(dlg_spec.script);
    writeln('//-->\n</SCRIPT>');
  }

  if (dlg_spec.reloadopener)
  {
    writeln('<SCRIPT>\n<!--\n');
    writeln('if (opener && opener.window != this.window){');
    writeln('  openloc=opener.location.href;');
    writeln('  intidx=openloc.indexOf(";internal");');
    writeln('  if (intidx>0){openloc=openloc.substring(0,intidx);}');
    writeln('  functionStr="opener.window.location.replace(\'"+openloc+"\')";');
    writeln('  eval(functionStr);');
    writeln('  setCookie("HW_Reload","yes",null);}');
    writeln('//-->\n</SCRIPT>');
  }

  var has_required=HW_DC_incConfirmScripts(params);

  writeln("</HEAD>");
  // ----------- HEAD END  ----------------

  // ----------- BODY START  ----------------
  write('<BODY BGCOLOR="'+dlg_spec.style.BGColor+'" TEXT="'+dlg_spec.style.Color+'" ');
  var onload="";
  if (dlg_spec.onload)
    onload="ONLOAD='"+dlg_spec.onload+";";
  if (dlg_spec.moreless)
    onload+=(onload?"":"ONLOAD='")+'restoreFormValuesFromCookie("'+dlg_spec.formname+'");';
  if (onload) write(onload+"'");
  writeln(">");

  // ----------- FORM START  ----------------
  write('<FORM method=POST NAME="'+dlg_spec.formname+'" ');
  if (HW_formIsMultiPart)
    write('ENCTYPE="multipart/form-data" ');

  var begin="onSubmit='return ";
  var mid=' && ';
  var onsub="";
  if (dlg_spec.onsubmitfirst)
    onsub=begin+dlg_spec.onsubmitfirst;
  if (global_confScriptInserted)
    onsub+=(onsub?mid:begin)+'HW_DC_verifySubmit(this)';
  if (dlg_spec.onsubmit)
    onsub+=(onsub?mid:begin)+dlg_spec.onsubmit.replace(/^\s*return /,"");
  if (onsub) write(onsub+"'");

  if (typeof dlg_spec.formaction != "undefined")
    write(' action="'+dlg_spec.formaction+'"');
  writeln('>');
  
  var igCap=dlg_spec.style.ignoreDlgCap || hw_dlgStyle.ignoreDlgCap;
  var igDescr=dlg_spec.style.ignoreDlgDescr || hw_dlgStyle.ignoreDlgDescr;
  var igNecessary=dlg_spec.style.ignoreDlgNecessary || hw_dlgStyle.ignoreDlgNecessary;
  if (!dlg_spec.nocenter) writeln('<CENTER>');
  write('<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" ALIGN="CENTER"'); //"Super"-Table
  dlg_spec.boxwidth=dlg_spec.boxwidth || dlg_spec.style.boxwidth || "250";
  writeln(' WIDTH="'+dlg_spec.boxwidth+'">');
  writeln('<TR><TD COLSPAN="3"><TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="1"><TR>');
  var bgcolor=(!igCap && dlg_spec.style.capBGColor)?(' BGCOLOR="'+dlg_spec.style.capBGColor+'"'):'';
  writeln('<TD WIDTH="100%"'+bgcolor+'>');

  if (!(igCap && igDescr && igNecessary))
  {
    var capstyle=dlg_spec.style.capStyle?('style="'+dlg_spec.style.capStyle+'"'):"class=Caption";
    var descstyle=dlg_spec.style.descStyle?('style="'+dlg_spec.style.descStyle+'"'):"class=Desc";
    if (!igCap && dlg_spec.caption)
      write("<SPAN "+capstyle+">&nbsp;"+dlg_spec.caption+"</SPAN><BR>");
    if (!igDescr && typeof dlg_spec.descr != "undefined")
      writeln("<SPAN "+descstyle+">"+dlg_spec.descr+"</SPAN><BR>");
    if (!igNecessary && has_required && !dlg_spec.descr)
      writeln("<SPAN "+descstyle+">"+lrc("reqfield","hwrc","* indicates a required field")+".</SPAN>");
  }
  writeln('</TD>');
  if (dlg_spec.style.logo)
  {
    bgcolor=dlg_spec.style.logoBGColor?(' BGCOLOR="'+dlg_spec.style.logoBGColor+'"'):'';
    writeln('<TD ALIGN="right" WIDTH="1" '+bgcolor+'><IMG SRC="'+dlg_spec.style.logo+'"></TD>');
  }
  //  if (!(igCap && igDescr && igNecessary))
  //  writeln('</TR><TR><TD COLSPAN="3">&nbsp;<BR></TD>');
  writeln('</TR></TABLE></TD></TR>');

  //  writeln('<TR><TD COLSPAN="3"><IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/empty.gif" HEIGHT="1" WIDTH="'+dlg_spec.boxwidth+'"></TD></TR>');
  writeln('<tr><td>&nbsp;</td><td><table width="',(dlg_spec.boxwidth-11),'" border="0" cellspacing="0" cellpadding="0">');
  //  writeln('<tr><td><IMG SRC="/wavemaster.internal/v1.0/uistyle/icons/empty.gif" HEIGHT="1" WIDTH="'+dlg_spec.boxwidth+'"></td></tr></table></td><td>&nbsp;</td></tr>');
  writeln('<tr><td>&nbsp;</td></tr></table></td><td>&nbsp;</td></tr>');
}

// *******************************************************************
// creates the footer (buttons,...) of a dialog.
// *******************************************************************
function HW_DC_dialogFooter(dlg_spec)
{
  HW_dialogFooter(dlg_spec,true);
}

function HW_dialogFooter(dlg_spec,cls)
{
  var closebox=cls || false;
  if (typeof dlg_spec.style=='undefined')
    dlg_spec.style = dstyle;
  if (!dlg_spec.formname)
    dlg_spec.formname="f1";

  if (closebox)
    write(tableRowRightBottom(dlg_spec.style,{}));
  writeln("\n<!-- OK/CANCEL BUTTONS BORDER -->");
  writeln("  <TR>");
  writeln('    <TD COLSPAN="3" ALIGN="RIGHT"><BR>');

  // ----------- BUTTONS ----------------
  if (typeof dlg_spec.buttons != "undefined")
    write(dialogButtons(dlg_spec.buttons));

  writeln("    </TD>");
  writeln("  </TR>");
  writeln("</TABLE>"); //"Super"-Table
  if (!dlg_spec.nocenter) writeln("</CENTER>");
  writeln("</FORM>");
  if (hw_dc_writesinkform)
    writeSubmitSink(dlg_spec);
  writeln("</BODY>");
  writeln("</HTML>");
}

function set_focus(fname,elemname)
{
  writeln('<SCRIPT>\nglobal_onload=window.onload;window.onload=onloadfunc;');
  writeln('function onloadfunc(){\ndocument.'+fname+'["'+elemname+'"].focus();');
  writeln('if (typeof global_onload=="function") global_onload();}\n</SCRIPT>');
}

function inputelem_begin(specs)
{
  writeln('  <TR><TD WIDTH="170" ALIGN="RIGHT"><SPAN class=AttrName>'+getCaption(specs,1));
  writeln('  </SPAN></TD>');
}

// *******************************************************************
// creates a text input field. (very general, with visualize, etc..)
// *******************************************************************
function writeInputField(specs)
{
  var vi=specs.visualize||{};
  writeln('<TD WIDTH="170" ALIGN="RIGHT"><SPAN class=AttrName>'+getCaption(specs,1)+'</SPAN></TD>');
  write('<TD WIDTH="270">');
  var theType=specs.type=="password"?"PASSWORD":"TEXT";
  write('<INPUT TYPE='+theType+(vi.style?(' style="'+vi.style+'" '):' '));
  if (specs.name)
    write('NAME="'+((specs.prefix)?specs.prefix:'')+specs.name+'" ');
  if (typeof specs.def != "undefined")
  {
    if (specs.type=="HW_API_LanguageString" && typeof specs.def.string !="undefined")
      write('VALUE="'+specs.def.string.toString().replace(/\"/gi,'&quot;')+'" ');
    else
    {
      write('VALUE="');
      if (specs.type=="time")
        write(transformDate(specs.def,HWDate,HW_UI_Date.full,false)+'" ');
      else
        write(specs.def.toString().replace(/\"/g,'&quot;')+'" ');
    }
  }
  var fallb=(specs.type=="float" || specs.type=="integer")?"22":"30";
  write("SIZE="+(vi.cols || fallb)+">");
  if (specs.necessity=='required') write("* ");
  if (specs.range && (typeof specs.range.lower != "undefined" || typeof specs.range.upper != "undefined"))
    write("<SPAN class=Desc>("+((typeof specs.range.lower!="undefined") ? specs.range.lower : "~")+","+((typeof specs.range.upper!="undefined") ? specs.range.upper : "~")+")</SPAN>");
  else if (specs.type=="float" || specs.type=="integer")
    write("<SPAN class=Desc>"+lrc("ddDlgTxt1","lib","Number")+"</SPAN>");
}

// *******************************************************************
// creates a text input field or a textarea.
// *******************************************************************
function HW_DC_createInputField(specs,dlg_spec)
{
  // If 'creator' mode and field name is 'Parent' -> special case
  if (typeof dlg_spec!='undefined' && dlg_spec.creator==true && specs.name=='parentidentifier')
  {
    inputelem_begin(specs);
    write('<TD WIDTH="270"><SPAN class=AttrValue>'+request.object.getTitle());
    writeln("</SPAN></TD></TR>");
    writeln('<INPUT TYPE="HIDDEN" NAME="parentidentifier" VALUE="'+request.object.getGOid()+'">');
    return;
  }

  var elemname=((specs.prefix)?specs.prefix:'')+specs.name;
  var vi=specs.visualize||{};
  if (vi.rows && (vi.rows-0)>1) // Textarea:
  {
    if (specs.caption)
      inputelem_begin(specs);
    write('<TD COLSPAN="3" VALIGN="MIDDLE">')
    if (vi.style) write('<SPAN style="'+vi.style+'">');
    write('<TEXTAREA NAME="'+elemname+'"');
    for (var i in vi)
      if (i!="style") write(' '+i+'="'+vi[i]+'"');
    writeln('>'+(specs.def?specs.def.toString().replace(/\"/g,'&quot;'):"")+'</TEXTAREA>');
    if (vi.style) write('</SPAN>');
  }
  else // Input field:
  {
    writeln('<TR>');
    writeInputField(specs);
  }
  writeln("</TD></TR>");
  if (specs.focus) //set focus to input element
    set_focus(dlg_spec.formname,elemname);
}

// *******************************************************************
// creates a input field + list box for a language dependant string
// *******************************************************************
function HW_DC_createLanguageString(specs,dlg_s) {
  var dlg_spec=dlg_s || {};
  writeln("  <TR>");
  writeInputField(specs);
  // ListBox:
  write("\n<SELECT ");
  var elem=((specs.prefix)?specs.prefix:'')+specs.name;
  if (specs.name)
    write('NAME="'+elem+'_ddlang"');
  writeln(">");

  var langpar=(specs.def && typeof specs.def.language != "undefined")?{selLang:specs.def.language}:{};
  write_languageoptions(langpar);
  writeln('</SELECT>\n<INPUT TYPE="HIDDEN" NAME="'+elem+'_ddhidden"></TD></TR>');
  if (specs.focus) //set focus to input element
    set_focus(dlg_spec.formname||"forms[0]",elem);
}

// *******************************************************************
// creates a listbox for an enum list.
// *******************************************************************
function HW_DC_createListBox(specs)
{
  inputelem_begin(specs);
  // ListBox:
  write("    <TD> <SELECT ");
  if (specs.name)
    write('NAME="'+((specs.prefix)?specs.prefix:'')+specs.name+'" ');
  if (specs.onchange)
    write('onchange="'+specs.onchange+'"');
  write(">");

  var v = specs.values;
  for (var i in v); //##### workaround for bug in waveslave....
  var selected=(typeof specs.def=="undefined")?v[0].value:specs.def;
  var noneselected=true;
  for (var i in v)
    if (typeof v[i].value != 'undefined' && typeof v[i].caption != 'undefined') 
    {
      write('<OPTION VALUE="'+v[i].value+'"');
      if (noneselected && v[i].value==selected)
      {
        write(" SELECTED");
        noneselected=false;
      }
      writeln(">"+getCaption(v[i]));
    }
  write("</SELECT>");
  if (specs.necessity=='required') writeln(" *");
  writeln("    </TD>");
  writeln("  </TR>");
}

// *******************************************************************
// creates a simple checkbox (no hidden field in behind), a boolean
// checkbox (hidden field transports information, "true" if checked,
// "false" otherwise, or a general checkbox (hidden field, transports
// given checkedValue if checked, notcheckedValue if not checked).
// *******************************************************************
function HW_DC_createCheckBox(specs)
{
  inputelem_begin(specs);
  write('<TD><INPUT TYPE="checkbox" ');
  if (specs.name)
    write('NAME="'+((specs.prefix)?specs.prefix:'')+specs.name+'" ');
  if (specs.def)
    write("CHECKED");
  if (specs.subtype=="simple")
    writeln(' VALUE="'+(typeof specs.checkedValue != "undefined"?specs.checkedValue:"true")+'">');
  else
    writeln('>\n<INPUT TYPE="HIDDEN" NAME="'+((specs.prefix)?specs.prefix:'')+specs.name+'_s">');
  if (specs.descr)
    writeln('<SPAN class=AttrValue>'+specs.descr+'</SPAN>');
  writeln("  </TD></TR>");
}

// *******************************************************************
// creates a input field and a (HW)browse button.
// *******************************************************************

var hw_dc_writesinkform=false;
function writeSubmitSink(dlgspec)
{
  write(openDialogFunction());
  if (!dlgspec.formname)
    dlgspec.formname="f1";
  var inputname=place("movecopy.object.form.destination");
  writeln('<FORM Name="bodyform">');
  writeln('<INPUT TYPE="HIDDEN" NAME="',inputname,'" VALUE="">');
  writeln('</FORM>');
  writeln('<SCRIPT>\n<!--');
  writeln('var hw_dc_browsefor="";');
  writeln('function submitform(){');
  writeln('var theform=document.bodyform;');
  writeln('document.',dlgspec.formname,'[hw_dc_browsefor].value=theform["',inputname,'"].value;');
  writeln('theform["',inputname,'"].value="";');
  writeln('}');
  writeln('function openBrowser(name){');
  writeln('hw_dc_browsefor=name;');
  writeln(opDlgScr({target:"hwbrowser",act:"dialog.choosetarget",actp:"DCPTR",funconly:true}),';');
  writeln('}');
  writeln('//-->');
  writeln('</SCRIPT>');
}

// *******************************************************************
// creates a input field + button  for a PTR
// *******************************************************************
function HW_DC_createPTRField(specs)
{
  inputelem_begin(specs);
  // Input field:
  write('    <TD WIDTH="270"><INPUT TYPE="Text" ');
  if (specs.name)
    write('NAME="'+((specs.prefix)?specs.prefix:'')+specs.name+'" ');
  if (specs.def)
    write('VALUE="'+specs.def.objectidentifier.toString().replace(/\"/gi,'&quot;')+'" ');
  write("SIZE=30 ");
  write(">");
  if (typeof specs.necessity!='undefined' && specs.necessity=='required')
    write("*");
  writeln('<INPUT TYPE="BUTTON" onclick="return openBrowser(\'',((specs.prefix)?specs.prefix:'')+specs.name,'\')" VALUE="Browse">');
  hw_dc_writesinkform=true;
  writeln("</TD>");
  writeln("  </TR>");
}

// *******************************************************************
// creates a file input field.
// *******************************************************************
function HW_DC_createFile(specs,dlg_s) {

  var dlg_spec=dlg_s || {};
  inputelem_begin(specs);
  // Input field:
  write('    <TD WIDTH="270"><INPUT TYPE="FILE" ');
  var elemname=((specs.prefix)?specs.prefix:'')+specs.name;
  if (specs.name)
    write('NAME="'+elemname+'" ');
  if (specs.def)
    write('VALUE="'+specs.def.toString().replace(/\"/gi,'&quot;')+'" ');
  write("SIZE=20 ");
  write(">");
  if (specs.necessity=='required')
    write("*");

  writeln("</TD>");
  writeln("  </TR>");
  if (specs.focus) //set focus to input element
    set_focus(dlg_spec.formname||"forms[0]",elemname);
}

// *******************************************************************
// writes the icon,HTML and scripts for a DateControl element. 
// *******************************************************************
function HW_DC_dateControl(specs,formname)
{
  if (typeof global_datecontrolScriptswritten == "undefined")
  {
    writeln('<SCRIPT>'+udcScripts+'</SCRIPT>');
    writeln('<SCRIPT SRC="/wavemaster.internal/v1.0/components/misc/code/form_elem_idx.js"></SCRIPT>');
    global_datecontrolScriptswritten=true;
  }
  writeln('<TR>');
  if (!specs.name)
    specs.name="default";
  writeInputField(specs);
  DateControl({FormName:formname,FormElement:specs.name,Mode:specs.subtype});
  writeln('</TD></TR>');
}

// *******************************************************************
// creates custom input fields. Every attribute that is specified in
// ".db.contr.rc (for example: "WAVESTORE::CUSTOMINDEX[custom1] = Keyword")
// will be shown (=queried).
// *******************************************************************
function HW_DC_createCustomInput(specs)
{
  var pre=specs.prefix?specs.prefix:"";
  custom_inputs(pre);
}

// *******************************************************************
// creates user input field (user can enter any key/value pair he wants.)
// *******************************************************************
function HW_DC_createUserInput(specs)
{
  var pre=specs.prefix?specs.prefix:"";
  user_input(pre);
}

// *******************************************************************
// Simply inserts the given macro
// *******************************************************************
function HW_DC_plainmacro(specs)
{
  if (specs.name) hw_writePLACEWithError(specs.name);
}

// *******************************************************************
// Simply writes the text given in the string specs.def
// *******************************************************************
function HW_DC_plaintext(specs)
{
  if (specs.trtd) writeln("<TR><TD>");
  if (specs.def) writeln(specs.def);
  if (specs.trtd) writeln("</TD></TR>");
}

// *******************************************************************
// Executes the SSJS-function given in specs.name. specs.name is a string
// and  therefore it can also contain calling parameters !.
// It is expected that the function writes HTML content with or without 
// surrounding <TR><TD>'s. (the parameter trtd has to be set accordingly...)
// *******************************************************************
function HW_DC_plainfunction(specs)
{
  if (specs.trtd) writeln("<TR><TD>");
  if (specs.name) eval(specs.name);
  if (specs.trtd) writeln("</TD></TR>");
}

// *******************************************************************
// Inserts more/less button
// *******************************************************************
function HW_DC_moreless(typ)
{
  writeln('<TR><TD COLSPAN="3" ALIGN=CENTER>')
  writeln(dialogButtons({x:{func:typ,actp:escape(request.actp)}}));
  writeln('</TD></TR>');
}

// *******************************************************************
// Inserts the required Attributes
// *******************************************************************
function HW_DC_requiredAttributes(specs)
{
  if (typeof global_reqAttr != "undefined" && global_reqAttr)
  {
    HW_DC_dialogContent([{paramspecs:global_reqAttr}]);
    if (specs.subtype=="inherit")
      HW_copyRequiredAttributes();
  }
}

// *******************************************************************
// Inserts an input field plus "Browse..." button to search for a target
// collection.
// *******************************************************************
function HW_DC_chooseTheTarget(specs,dlgspec)
{
  writeln("<TR>");
  if (typeof specs.def == "undefined") specs.def=place("last_editable_collection");
  writeInputField(specs);
  writeln('\n<INPUT TYPE=BUTTON VALUE="'+lrc('ddFrmLbl1','lib','Browse')+'..." onclick="opDlg(\'/'+specs.def+';internal&action=dialog.choosetarget.action&Parameter=collection^'+dlgspec.formname+'^'+specs.name+'\',\'chooseCol\')">');
  writeln("</TD></TR>");
}

// *******************************************************************
// creates a hidden input element, when prompt in param_specs is false
// *******************************************************************
function HW_DC_addHiddenGUIElement (specs) {
  if (specs.name) {
    // insert hidden input field
    write('<INPUT TYPE="HIDDEN" NAME="'+((specs.prefix)?specs.prefix:'')+specs.name+'"');
    write(' VALUE="'+(specs.def?specs.def.toString().replace(/\"/g,'&quot;'):"")+'"');
    writeln('>');
  }
  if (specs.caption && typeof specs.descr != 'undefined')
  {
    writeln('<TR><TD ALIGN="RIGHT"><SPAN class=AttrName>'+getCaption(specs,1)+'</SPAN></TD>');
    if (specs.type=="time")
      specs.descr='<SCRIPT>document.write(transformDate("'+specs.descr+'",HWDate,HW_UI_Date.full,false));</SCRIPT>';
    writeln('<TD><SPAN class=AttrValue>'+specs.descr+'</SPAN></TD></TR>');
  }
}

// *******************************************************************
// creates the content (input mask,...) of a dialog.
// *******************************************************************
function HW_DC_dialogContent(params,dlg_spec)
{
  var parArray=params||[];
  for (var x=0;x<parArray.length;x++)
  {
    if (x>0)
      writeln('<TR><TD COLSPAN="3"><HR></TD></TR>'); //separating HR after each paramspecs block

    var p_spec=parArray[x].paramspecs;
    for (var i=0;i<p_spec.length;i++)
    {
      var ps=p_spec[i];
      var typ=ps.type;
      if (parArray[x].prefix)
        ps.prefix = parArray[x].prefix;

      if (typeof ps.prompt == 'undefined' || ps.prompt)
      {
        // ignore if out parameter or hw_requiredattributes (Document Classes...)
        if (ps.inout=="out" || ps.name=="hw_requiredattributes") continue;

        if (typ == 'boolean' || typ=='checkbox')
          HW_DC_createCheckBox(ps);
        else if (typ == 'HW_DC_API_Pointer')
        {
          // create formfield with browse button
          if (ps.name!="hw_this")
            HW_DC_createPTRField(ps);
        }
        else if (typ == 'HW_API_LanguageString')
          HW_DC_createLanguageString(ps,dlg_spec);
        else if (typ == 'HW_API_Content')
          HW_DC_createFile(ps,dlg_spec);
        else if (typ == "wizard")
          insertWizard(ps);  //defined in lib/insertWizard.js
        else if (typ == "datecontrol")
          HW_DC_dateControl(ps,dlg_spec.formname);
        else if (typ == 'customInput')
          HW_DC_createCustomInput(ps);
        else if (typ == 'userInput')
          HW_DC_createUserInput(ps);
        else if (typ == 'plainmacro')
          HW_DC_plainmacro(ps);
        else if (typ == 'plaintext')
          HW_DC_plaintext(ps);
        else if (typ == 'plainfunction')
          HW_DC_plainfunction(ps);
        else if (typ == 'more' || typ == 'less')
          HW_DC_moreless(typ);
        else if (typ == 'reqAttr')
          HW_DC_requiredAttributes(ps);
        else if (typ == 'choosetarget')
          HW_DC_chooseTheTarget(ps,dlg_spec);
        else if (typeof ps.values != 'undefined' && ps.values.length > 0)
          HW_DC_createListBox(ps);
        else if (!(typ == "HW_DC_API_ClassDefinition" && ps.name=="hw_class"))
// default: just create an input field (handles type "string", "time", "password", "integer", "float")
          HW_DC_createInputField(ps,dlg_spec);
      }
      else
        HW_DC_addHiddenGUIElement(ps);
    }
  }
}

// *******************************************************************
// creates a dialog along the dialog and parameter specification
// provided.
// *******************************************************************
function HW_DC_defaultDialog(dlg_spec,param_specs) 
{
  HW_DC_dialogHeader(dlg_spec,param_specs);
  writeln('<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="0" WIDTH="100%">');
  HW_DC_dialogContent(param_specs,dlg_spec);
  writeln('</TABLE>');
  HW_DC_dialogFooter(dlg_spec);
}

// *******************************************************************
// creates a dialog along the dialog and parameter specifications
// provided. It is more general than HW_DC_defaultDialog, allowing
// multiple boxes. dlg_spec has the same structure as always, multi_specs
// looks like this: [{caption:"abc",boxes:[xxx]},{...}]. So we have an
// array (outer []) of boxes, each with a caption (in this example "abc").
// The inner [] is the usual array of parameter-specifications, which is
// the "param_specs" parameter in the HW_DC_defaultDialog() function.
// *******************************************************************
function HW_DC_defaultMultiDialog(dlg_spec,m_specs)
{
  var multi_specs=m_specs || []; 
  HW_dialogHeader(dlg_spec,multi_specs);
  for (var x=0;x<multi_specs.length;x++)
  {
    var ms=multi_specs[x];
    write_topofBox(dlg_spec,ms.caption); //---top of box---
    writeln('<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="0" WIDTH="100%">');
    HW_DC_dialogContent(ms.boxes,dlg_spec);//---content---
    writeln('</TABLE>');
    write(tableRowRightBottom(dlg_spec.style,{})); //---bottom of box---
  }
  HW_dialogFooter(dlg_spec);
}

// *******************************************************************
// copies the HW_ReqChildAttr in hidden fields - used when inserting
// a new collection/cluster
// *******************************************************************
function HW_copyRequiredAttributes() {
  if (typeof request.object.HW_ReqChildAttr!='undefined') {
    var params = request.object.attribute('HW_ReqChildAttr').values;
    for (var x=0; x < params.length; x++) {
      HW_DC_addHiddenGUIElement({name:'HW_ReqChildAttr',def:params[x].replace(/\"/gi,'&quot;')});
    }
  }
}

function HW_DC_writelnErrorAlert(e)
{
  if (typeof global_confScriptInserted=="undefined") //if defined, the <SCRIPT> is already there
    writeln('<SCRIPT>\n<!--');
  var error_str = lrc("ddErrMsg1","lib","Required Attributes Malformed!\\n\\nParsing the required Attributes lead to following error(s):\\n\\n");

  // add all parser error messages to error message string
  for (var x in e)
  {
    //error_str += e[x].type+'\\n';
    error_str += '   '+e[x].source+' ';
    error_str += '   '+e[x].code+' ';
    error_str += '    '+e[x].description(client.language)+'\\n';
  }
  error_str +=lrc("ddErrMsg2","lib","\\nThe Required Attributes will NOT be attached to the new object!\\nContact your administrator to correct the 'HW_ReqChildAttr' attribute.\\n");
  //  error_str=error_str.replace(/\\/g,'\\\\');
  error_str=error_str.replace(/\"/g,'\\\"');
  error_str=error_str.replace(/\n/g,'\\n');
  error_str=error_str.replace(/\r/g,'');

  writeln('alert("'+error_str+'")');
  if (typeof global_confScriptInserted=="undefined")
    writeln('// -->\n</SCRIPT>');
}

// *******************************************************************
// Gets the HW_ReqChildAttr of the current object and returns the
// parsed value. If no such attribute is available or parsing failed
// nothing (aka 'undefined') is returned.
// *******************************************************************
function HW_DC_getRequiredAttributes(p) {
  if (typeof p =="undefined")
    p={};
  if (typeof request.object.HW_ReqChildAttr!='undefined') {
    // parse HW_ReqChildAttr
    var ps = HW_DC_API_ParamSpecArray();
    var e = ps.parse (request.object.attribute('HW_ReqChildAttr').values);

    // on error display dialogbox
    if (e.error() && !p.noerror) {
      HW_DC_writelnErrorAlert(e);
    }
    else {
      // no error?
      var paraout=ps.filldefaults(request.object.GOid,server);
      if (paraout.error.error())
      {
        HW_DC_writelnErrorAlert(paraout.error);
      }
      else
        ps=paraout.paramspecs;
     return ps;
    }
  }
  return void 0;
}

// *******************************************************************
// generates the HTML for a help dialog, "dlg_spec" is same as always.
// "params" looks like:[{caption:"...",content},{..}], where content can
// either be >>>macro:"macroname"<<< or >>>text:"a simple text"<<<
// *******************************************************************
function HW_helpDialog(dlg_spec,params)
{
  var elem;
  var parspecs=[];
  for (var x=0;x<params.length;x++)
  {
    elem=params[x].macro?{type:"plainmacro",name:params[x].macro}:{type:"plaintext",def:params[x].text,trtd:params[x].trtd};
    parspecs[parspecs.length]={caption:params[x].caption,boxes:[{paramspecs:[elem]}]};
  }
  dlg_spec.style=dlg_spec.style || hlpstyle || hlpstyel;  //helpstyle
  HW_DC_defaultMultiDialog(dlg_spec,parspecs)
}
