var CS_TREE = {};
// determines how many levels are viewed as full tree
// set to -1 for full tree regardless of the level
CS_TREE.nrOfFulltreeLevels = -1;
CS_TREE.helpFrame = "HW_DataRequestFrame";

// ************************ TOPFRAME  functions (don't  need top) ************************

opDlg = top.opDlg;

function cs_getPath(id,ctv,cpath) 
{
  if (ctv != null)
  {
    for (var x in ctv) 
    {
      if (!isNaN(x) && (x!=-1))
      {
              // check if this is what we are looking for
        if ((ctv[x].G==id) || (ctv[x].N==id))
        {
                // cut last element if it is not in treeview types
          if (ctv[x].DT == "collection")
            cpath=cpath.concat([x]);
          return {path:cpath,object:ctv[x],found:1};
          
        } // if
        
              // search down recursively
        if (cs_tree_getChildren(ctv[x])) 
        {
          var res = cs_getPath(id,cs_tree_getChildren(ctv[x]),cpath.concat([x]));
          if (res.found)
            return res;
        }
      } // if
    } // for x
  }
        // removing this entry
  return {path:cpath.slice(0,cpath.length-1),object:{},found:0};
}


function cs_checkPath (obj, ctv, cpath)
{
        // backwards compatibility because of document classes
  if (typeof obj=="string") obj = {G:obj};

  if ((typeof ctv != "object") || (typeof cpath != "object"))
    return false;

  if (ctv.length<=0 || cpath.length<=0)
    return false;

  var tobj = ctv[cpath[0]];
  if (typeof tobj != "object")
    return false;

  for (var i=1; i<cpath.length; i++)
  {
    tobj = cs_tree_getChildren(tobj);
    if ((typeof tobj != "object") || (tobj == null))
      return false;
    tobj = tobj[cpath[i]];
  }
  
  if (typeof(tobj)=="object")
  {
    if ((tobj.G==obj.goid) || (tobj.N==obj.name))
      return true;

    if (obj.HWAT=="Configuration" && typeof(obj.HWC)=="string" && tobj.G==obj.HWC.replace(" ","_"))
      return true;
  }

  return false;
} 

function cs_getDCUrl (id, url, path)
{
  if (url.search(/onclick=\"([^\"]*)\"/gi) != -1)
  {
    var hstr = RegExp.$1;
    var index = url.indexOf(hstr);
    var pre = url.substring(0,index);
    var post = url.substring(index+hstr.length);
    url = pre + "openDC('" + id + "','" + escape(hstr) + "',[" + path.toString() + "]); return false" + post;
  }
  return url;
}


// ------------------------ TREE functions 
function cs_tree_popFirst(cpath) 
{
  var ret = [];
  for (var j=1;j<=cpath.length;j++) {
    if (typeof cpath[j] != "undefined")
      ret[j-1] = cpath[j];
  }
  return ret;
}

function cs_tree_getIndentStr(level) 
{
  if (navigator.appName!="Netscape") 
  {
    var indent = (top.tvcfg.indent * (level-1)) + top.tvcfg.offset;
    var ret = " style=\"margin-left: " + indent + "px;\"><TR>";
  } 
  else 
  {
    var ret = " CELLSPACING=\"0\" CELLPADDING=\"0\"><TR><TD>";
    for (var l=0;l<level;l++)
      ret += "&nbsp;&nbsp;&nbsp;";
    ret += "</TD>";
  }
  return ret;
}

function cs_tree_getChildren (obj)
{
  if ((typeof obj == "object") && (typeof obj.c_ == "object"))
    return obj.c_;

  return null;
}

function cs_tree_foldup (obj)
{
  if (obj.DT != "collection")
    return false;

        // check if object is a dc and of type object -> no children
  if (obj.DCI=="yes" && obj.DCO=="yes")
    return false;

  if (top.editmode)
    return true;  // in editmode open all collections
  
  if (!obj.CT)
    return true;  // ordinary collection

        // by default open collections of every CollectionType except
        // Cluster, AlternativeCluster, MultiCluster
  return ((obj.CT != "Cluster") &&
    (obj.CT != "AlternativeCluster") &&
    (obj.CT != "MultiCluster"));
}

function cs_tree_isNavigateable (obj)
{
  if (obj.PT == "yes")
    return false;

  if (!top.editmode && (obj.DF == "yes"))
    return false;

  if (!top.editmode && obj.CT && (obj.CT != "Collection") && (obj.CT != "Sequence") && (obj.CT!="ServColl") && (obj.CT!="Derived"))
    return false;

  if ((obj.DCI == "yes") && (obj.DCFS == "true"))
    return false;

  if (obj.CT=="ServColl" && (obj.HWPS=="DISABLED" || obj.HWSS=="DOWN" || obj.HWSS=="FORCED_DOWN" ))
    return false;

  return true;
}

function cs_tree_areChildrenStored (path)
{
  if ((typeof path == "object") && (typeof path[0] != "undefined"))
    var curobj = top.tv[path[0]];
  else
    return false;

  for (var i=1; i<path.length; i++)
  {
    if (typeof curobj == "object")
    {
      var next = cs_tree_getChildren(curobj);
      if (next != null)
        curobj = next[path[i]];
    }
    else return false;
  }
  return (cs_tree_getChildren(curobj) != null);
}

function cs_tree_emphasizeObject (obj, path, inpath)
{
  if (typeof(obj)=="object")
  {
    if (obj.G==top.req.goid) return true; 

    if (top.req.HWAT=="Configuration" && 
      typeof(top.req.HWC)=="string" && obj.G==top.req.HWC.replace(" ","_"))
      return true;

    if (inpath)
    {
      if (obj.DCFS=="true") return true;
      
      var ch = cs_tree_getChildren(obj);
      if ((path.length==1) && (ch!=null) && 
        ((typeof ch[path[0]]!="object") || 
          (typeof ch[path[0]]=="object") && (ch[path[0]].DT!="collection")))
        return true;
      
      var tobj = obj;
      
      for (var i=0; i<path.length; i++)
      {
        if (typeof(tobj) == "object")
        {
          var ch = cs_tree_getChildren(tobj);
          if (ch!=null)
          {
            if (typeof(ch[path[i]])=="object")
              if (cs_tree_displayableObject(ch[path[i]])) return false;
            tobj = ch[path[i]];
          }
        }
      }
      if (path.length>0) return true;
    }
  }
  return false;
}

function cs_tree_displayableObject (obj)
{
  if (!obj || !obj.G)
    return false;

  if (obj.ADD && obj.ADD.indexOf('skiptree')!=-1)
    return false;
  
  if (!top.editmode && ((obj.PH=="Hidden") || (obj.PH=="CollectionHead") || (obj.PH=="FullCollectionHead")))
    return false;
  
  if (!cs_tree_foldup(obj))
    return false;

  return true;
}


function cs_tree_PrintObject(obj,level,inpath,path,emph,anchor) 
{
        // check whether the object can/should be displayed
  if (!cs_tree_displayableObject(obj))
    return;
  
        // compute entry info
  var isrequested = (top.req.goid == obj.G);
  var indentstr = cs_tree_getIndentStr(level);
  var navigate = cs_tree_isNavigateable(obj);
  document.writeln("<TABLE" + indentstr + "<TD>");

        // display navigation images and links (plus/minus) 
  if (!inpath)
  {
    if (navigate) document.write("<A HREF=\"#\" ONCLICK=\"plus('" + (obj.N || obj.G) + "',["+path.toString()+"]); return false;\">");
    document.write("<IMG SRC=\"/v1.0/components/frameset/images/plus.gif;internal&inline=true\" BORDER=\"0\">");
  }
  else
  {
    if (navigate) document.write("<A HREF=\"#\" ONCLICK=\"minus('" + (obj.N || obj.G) + "',["+path.toString()+"]); return false;\">");
    document.write("<IMG SRC=\"/v1.0/components/frameset/images/minus.gif;internal&inline=true\" BORDER=\"0\">");
  }
  if (navigate) document.write("</A>");
  
        // compute link of objects
  var url = obj.U;
  if (url && ((url.search(/onclick/i)!=-1) || (url.search(/;internal&/i)!=-1))&&
    !(top.editmode && obj.DF))
  {
    var lstr = "<A HREF=\"";
    if (url.lastIndexOf('"') != (url.length-1))
      url += '\"';
    
    if (obj.DCI=="yes")
    {
      lstr += cs_getDCUrl((obj.N || obj.G),url, path);
    }
    else
    {
      lstr += url;

      if (url.search(/;internal&/i)!=-1)
      {
        lstr = lstr.substring(0,lstr.length-1);
        if (typeof path == "object")
          lstr += '&path='+escape(path.toString())+'"';
        lstr += ' TARGET=HW_Mainframe';
      }      
    }
    lstr += '>';
  }
  else
  {
    var lstr = "<A HREF=\"#\" ";
    lstr += "ONCLICK=\"";
    lstr += "return ld('" + (obj.N || obj.G) + "',[" + path.toString() + "]);";
    lstr += "\">";
  }
  
        // write image link
  document.write(lstr);
  
        // write icon
  document.write("<IMG SRC=\"");
  if (obj.I)
  {
    if ((inpath) && (obj.I=="collection.gif"))
      document.write("/icons/coll_open.gif");
    else
      document.write("/icons/" + obj.I);
  }
  else
  {
    if (obj.IC)
      document.write(obj.IC);
    else
      document.write("/icons/collection.gif");
  }
  document.write(";internal&inline=true\" BORDER=\"0\">");
  
  document.writeln("</A></TD><TD>");

        // write title link
  if (anchor) document.write('<A NAME="hw_cur"></A>');
  document.writeln(lstr);
  if (emph) document.write("<B>");
//  if (isrequested) document.write("<B>");
  document.writeln(unescape(obj.T));
//  if (isrequested) document.write("</B>");
  if (emph) document.write("</B>");
  document.writeln("</A>");
  document.writeln("</TD></TR></TABLE>");
}

// will be used in naviframe
function cs_tree_DisplayTree(ctv,cpath,clev,path) 
{
  if (typeof path != "object") path = [];

  if (cpath.length>0) 
  {
    var x = cpath[0];
          // this pops the first entry from the path array
    cpath = cs_tree_popFirst(cpath);
	
    if ((clev==0) || (clev <= CS_TREE.nrOfFulltreeLevels) || (CS_TREE.nrOfFulltreeLevels == -1)) 
    {
      for (var c in ctv) 
      {
        if (c==x) 
        {
          var emph = cs_tree_emphasizeObject(ctv[c],cpath,true);
          var anchor = false;
          if ((path.length>0) && (cs_tree_getChildren(ctv[c])!=null))
            anchor = (!cs_tree_displayableObject(cs_tree_getChildren(ctv[c])[cpath[0]]));
          cs_tree_PrintObject(ctv[c],clev,true,path.concat(c),emph,(anchor || (cpath.length==0)));
          if (ctv[c].DCFS!="true")
          {
            var ch = cs_tree_getChildren(ctv[c]);
            if (ch != null)
              cs_tree_DisplayTree(ch,cpath,clev+1,path.concat(c));
          }
        } 
        else 
        {
          var emph = cs_tree_emphasizeObject(ctv[c],cpath,false);
          cs_tree_PrintObject(ctv[c],clev,false,path.concat(c),emph,false);
        }
      }
    } 
    else 
    {
  			// print this path entry
      var emph = cs_tree_emphasizeObject(ctv[c],cpath,true);
      if ((path.length>0) && (cs_tree_getChildren(ctv[c])!=null))
        anchor = (!cs_tree_displayableObject(cs_tree_getChildren(ctv[c])[cpath[0]]));
      cs_tree_PrintObject(ctv[x],clev,true,path.concat(x),emph,(anchor || (cpath.length==0)));
      if (ctv[x].DCFS!="true")
      {
        var ch = cs_tree_getChildren(ctv[x]);
        if (ch != null)
          cs_tree_DisplayTree(ch,cpath,clev+1,path.concat(x));
      }
    }
  } 
  else 
  {
          // print the children
    for (var c in ctv)
    {
      var emph = cs_tree_emphasizeObject(ctv[c],cpath,false);
      cs_tree_PrintObject(ctv[c],clev,false,path.concat(c),emph,false);
    }
  } // if
}

// ------------------------ general functions 
function ld (id, path) 
{
  if (typeof path != "object")
  {
    var out = top.cs_getPath(id,top.tv,[]);
    var path = out.path;
  }
  top.tvcfg.path = path;
  top.frames["HW_Mainframe"].location.href="/"+id+";path="+escape(top.tvcfg.path.toString());
  return false;
}

function plus (id, path)
{
  if (typeof path != "object")
  {
    var out = top.cs_getPath(id,top.tv,[]);
    path = out.path;
  }
  top.tvcfg.path = path;
  var stored = cs_tree_areChildrenStored(top.tvcfg.path);
  if (!stored)
  {
    top.callServerFunction({serverFunctionName: "hw_cstree_writeTreeInfo", callback: "top.reload_navigation()", objectidentifier: id, parameters: {path: escape(top.tvcfg.path.toString()), all: false}});
  }
  else
  {
    self.location.reload();
  }
  return false;
} 

function minus (id, path)
{
  if (typeof path != "object")
  {
    var out = top.cs_getPath(id,top.tv,[]);
    path = out.path;
  }
  top.tvcfg.path = path;
  top.tvcfg.path = top.tvcfg.path.slice(0,-1);
  self.location.reload();
  return false;
}

function openDC (id, onclick, path)
{
  if (typeof path != "object")
  {
    var out = top.cs_getPath(id,top.tv,[]);
    var path = out.path;
  }
  top.tvcfg.path = path;
  var tonclick = unescape(onclick);
  tonclick = tonclick.substring(0,tonclick.indexOf("return"));
  eval(tonclick);
  return false;
}
