//--------------------------------------------------------------------------
// HW_getMenu returns a HW_SSJ_ReturnObject (retObj)
// containing the menu itmes for edit mode
// retObj.mainMenuBar contains the topmost menu
//--------------------------------------------------------------------------
function HW_getMenu()
{
  var retObj=new HW_SSJ_ReturnObject({description:"Hyperwave Menu Creation"});
  hw_menu_createStdMenuItems();

  //--------------------------------------------------------------------------
  // curobj: shortcut to request.object
  //--------------------------------------------------------------------------
  var curobj=request.object;

  //--------------------------------------------------------------------------
  // curstat: contains some often computed information about the current object
  // and user information
  //--------------------------------------------------------------------------
  var curstat = curstatObj();

  //--------------------------------------------------------------------------
  // Help menu
  //--------------------------------------------------------------------------
  var helpM=new Menu("HWHelpMenu",{menuconf:"mitemst",decoration:deco,preb:false});
  helpM.addContextHelp();

  helpM.add((lrc("Contents","hwrc","Contents"))+"...",{target:"HelpWindow",act:"dialog.mainhelp.hw_bhelp"});
  //  helpM.addSep();
  //  helpM.add("Hyperwave Home Page",{url:"http://www.hyperwave.com/",target:"hyperwave",winstyle:{minWidth:670,toolbar:"yes"}});

  //--------------------------------------------------------------------------
  // Site Menu
  //--------------------------------------------------------------------------
  var siteM=new Menu("HWsiteMenu",{menuconf:"mitemst",decoration:deco});
  //  siteM.addStdFunc("hwt_sear_search");
  //  siteM.addSep();
  siteM.add(lrc("SiteHome","hwrc","Site Home"),{key:"H",url:"%%hyper.object(rootcollection)%%"});
  siteM.add(lrc("UserHome","hwrc","User Home"),{key:"U",url:"%%action.call.home%%",isdisabled:curstat.noEditUser});
  if (place("serverpool.count"))
  {
    siteM.add("Server Pool",{url:"%%hyper.object(hw_server_pool)%%"});
  }
  siteM.addSep();
  siteM.addStdFunc("hwt_misc_changepassword");
  siteM.addStdFunc("hwt_misc_sethome");
  //  siteM.addStdFunc("hwt_misc_preferences");

  //--------------------------------------------------------------------------
  // Publish menu: submenu cluster
  //--------------------------------------------------------------------------
  newM=new Menu("HWNewMenu",{menuconf:"mitemst",decoration:deco});
  newM.addStdFunc("hwt_pub_NewCluster");
  newM.addStdFunc("hwt_pub_NewAltCluster");
  newM.addStdFunc("hwt_pub_NewMultCluster");
  //--------------------------------------------------------------------------
  // Publish Menu
  //--------------------------------------------------------------------------

  pubM=new Menu("HWPublishMenu",{menuconf:"mitemst",decoration:deco});
  pubM.addStdFunc("hwt_pub_NewFile");
  pubM.addSep();
  pubM.addStdFunc("hwt_pub_NewCollection");
  pubM.add("Cluster",{child:newM,isdisabled:!curstat.collAndEdit});
  pubM.addStdFunc("hwt_pub_NewSequence");
  pubM.addSep();
  pubM.addStdFunc("hwt_pub_NewForum");
  pubM.addSep();
  pubM.addStdFunc("hwt_pub_NewHTML");
  pubM.addStdFunc("hwt_pub_NewText");
  pubM.addSep();
  pubM.addStdFunc("hwt_pub_NewNote");
  pubM.addSep();
  pubM.addStdFunc("hwt_pub_NewRemote");
  pubM.addStdFunc("hwt_pub_NewCGI");
  pubM.addDCCreators({itemcount:5,subitemcount:20});
  //--------------------------------------------------------------------------
  // Hyperlink Menu
  //--------------------------------------------------------------------------
  hyplM=new Menu("HWHyperlinkMenu",{menuconf:"mitemst",decoration:deco});
  hyplM.addStdFunc("hwt_hlnk_NewLink");
  hyplM.addStdFunc("hwt_hlnk_ModifyLink");
  hyplM.addStdFunc("hwt_hlnk_DeleteLink");

  //--------------------------------------------------------------------------
  // Version Menu
  //--------------------------------------------------------------------------
  verM=new Menu("HWVermen",{menuconf:"mitemst",decoration:deco});
  verM.addStdFunc("hw_api_checkIn");
  verM.addStdFunc("hw_api_checkOut");
  verM.addStdFunc("hw_api_setCommittedVersion");
  verM.addStdFunc("hw_api_revert");
  verM.addStdFunc("hw_api_freeVersion");
  verM.addStdFunc("hw_api_removeVersion");
  verM.addStdFunc("hw_api_linkVersion");
  verM.addStdFunc("hw_api_history");
  verM.addStdFunc("hwt_vers_CheckedOutDocs");

  //--------------------------------------------------------------------------
  // Configuration Management Menu
  //--------------------------------------------------------------------------
  confMngM=new Menu("HWConfiguration",{menuconf:"mitemst",decoration:deco});
  confMngM.addStdFunc("hw_api_configurationHistory");
  confMngM.addStdFunc("hw_api_saveConfiguration");
  confMngM.addStdFunc("hw_api_mergeConfiguration");
  confMngM.addStdFunc("hw_api_restoreConfiguration");
  confMngM.addStdFunc("hw_api_removeConfiguration");

  //--------------------------------------------------------------------------
  // Releaseflow Menu
  //--------------------------------------------------------------------------
  relM=new Menu("HWRelmen",{menuconf:"mitemst",decoration:deco});
  relM.addStdFunc("hwt_relf_NewProc");
  relM.addStdFunc("hwt_relf_EditProc");
  relM.addStdFunc("hwt_relf_AssignProc");
  relM.addSep();
  relM.addStdFunc("hwt_relf_ShowOpenCases");
  relM.addSep();
  relM.addStdFunc("hwt_relf_CreateCases");
  relM.addStdFunc("hwt_relf_StartCase");
  relM.addStdFunc("hwt_relf_DeleteCase");
  relM.addSep();
  relM.addStdFunc("hwt_relf_StateOfCase");
  relM.addStdFunc("hwt_relf_CancelCase"); //Function has to be enabled in menustdfunc.js

  //--------------------------------------------------------------------------
  // Modify Menu
  //--------------------------------------------------------------------------
  editM=new Menu("HWEditMenu",{menuconf:"mitemst",decoration:deco});
  editM.add(lrc("SelAll","hwrc","Select All"),{isdisabled:(!curstat.isColl),exec:"selectAll(true)"});
  editM.add(lrc("DeSelAll","hwrc","Deselect All"),{isdisabled:(!curstat.isColl),exec:"selectAll(false)"});
  editM.addSep();
  editM.addStdFunc("hwt_mod_EditAttr");
  editM.addDCEdit();
  editM.addStdFunc("hwt_mod_EditQuery");
  editM.addStdFunc("hwt_mod_EditText");
  editM.addStdFunc("hwt_mod_EditHTML");
  editM.addSep();
  editM.add("Hyperlink",{child:hyplM});
  editM.addSep();
  editM.addStdFunc("hw_api_move");
  editM.addStdFunc("hw_api_link");
  editM.addStdFunc("hw_api_copy");
  editM.addStdFunc("hw_api_remove");
  editM.addStdFunc("hwt_mod_replace");
  editM.addSep();
  if (actionhandler.componentExists("versioncontrolmaster"))
    editM.add(lrc("VersionControl","hwrc","Version Control"),{child:verM});
  if (actionhandler.componentExists("confmngmaster"))
    editM.add(lrc("Configurations","hwrc","Configurations"),{child:confMngM});
  if (actionhandler.componentExists("relflowmaster"))
    editM.add(lrc("ReleaseFlow","hwrc","Release Flow"),{child:relM});
  editM.addStdFunc("hwt_mod_LockUnlock");
  if (client.DEVELOP=="yes")
  {
    editM.addSep();
    editM.addStdFunc("hwt_menu_clearDCCache");
  }
  //  if (curstat.isSystem || (typeof client.DEVELOP!="undefined"))
  //{
  //  editM.add(lrc("DCDevremove","hwrc","DC Developmode"),{act:"_setlanguage",actp:((client.DEVELOP=="yes")?"DEVELOP=no":"DEVELOP=yes"),ischecked:(client.DEVELOP=="yes")});
  //}

  //--------------------------------------------------------------------------
  // View Menu
  //--------------------------------------------------------------------------
  var propM=new Menu("HWPropMenu",{menuconf:"mitemst",decoration:deco});
  propM.addStdFunc("hwt_view_ViewAttr");
  propM.addDCShow();
  propM.addStdFunc("hwt_view_HeadFoot");
  propM.addStdFunc("hwt_view_LinkMap");
  propM.addStdFunc("hwt_view_SimDocs");
  propM.addStdFunc("hwt_view_Notes");

  //--------------------------------------------------------------------------
  // Admin Menu
  //--------------------------------------------------------------------------
  if (actionhandler.componentExists("adminmaster"))
  {
    var admM=new Menu("HWAdmMenu",{menuconf:"mitemst",decoration:deco,preb:false});
    admM.addStdFunc("hwt_admi_newuser");
    admM.addStdFunc("hwt_admi_newgroup");
    admM.addStdFunc("hwt_admi_editdeleteUG");
    admM.addStdFunc("hwt_admi_assignUG");
    admM.addSep();
    admM.addStdFunc("hwt_admi_serverstatus");
    admM.addStdFunc("hwt_admi_whoisonline");
    admM.addSep();
    admM.addStdFunc("hwt_admi_adminpool");
    admM.addSep();
    admM.addStdFunc("hwt_admi_install");
    admM.addSep();
    admM.addStdFunc("hwt_admi_logo");
  }
  //--------------------------------------------------------------------------
  // The Menu Bar
  //--------------------------------------------------------------------------
  var objiden="";
  if (!curobj.Name || curobj.Serv)
    objiden=curobj.getGOid();
  else
    objiden=curobj.Name;
  var thebase=place("gate.protocol")+"://"+place("gate.hostname_with_port")+"/"+objiden+hw_extractVersionURL();

  var hwbar=new Menu("HWMainMenu",{savepos:true,width:"100%",menuconf:"mbarst", orientation:"top",decoration:deco,obj:thebase});
  hwbar.add(lrc("Site","hwrc","Site"),{child:siteM});
  hwbar.add(lrc("Publish","hwrc","Publish"),{child:pubM,isdisabled:(curstat.isSavedConfiguration)});
  hwbar.add(lrc("Modify","hwrc","Modify"),{child:editM,isdisabled:(curstat.isSavedConfiguration)});
  hwbar.add(lrc("View","hwrc","View"),{child:propM});
  hwbar.addDCMethodsItem({menuconf:"mitemst",decoration:deco});
  if (curstat.isSystem && actionhandler.componentExists("adminmaster"))
  {
    hwbar.add("Admin",{child:admM});
  }
  //  hwbar.addStdFunc("hwt_misc_login");
  hwbar.add(lrc("Help","hwrc","Help"),{child:helpM});
  hwbar.addHSpace();

//    hwbar.addStdFunc("hwt_misc_authoring");
//    hwbar.addStdFunc("hw_api_parents");
  retObj.mainMenuBar=hwbar;
  return retObj;
}

function HW_getMenuViewMode()
{
  var curobj=request.object;
  var objiden="";
  if (!curobj.Name || curobj.Serv)
    objiden=curobj.getGOid();
  else
    objiden=curobj.Name;

  var thebase=place("gate.protocol")+"://"+place("gate.hostname_with_port")+"/"+objiden+hw_extractVersionURL();
  var hwbar=new Menu("HWMainMenu",{width:"100%",menuconf:"mbarst", orientation:"top",decoration:deco,obj:thebase});
  var retObj=new HW_SSJ_ReturnObject({description:"Hyperwave Menu Creation"});

  // add a dummy entry
  hwbar.addDCMethodsItem({menuconf:"mitemst",decoration:deco,close:true});
  hwbar.add("&nbsp;",{isdisabled:true});
  hwbar.addHSpace();

  retObj.mainMenuBar=hwbar;
  return retObj;
}

//--------------------------------------------------------------------------
// HW_getMenuObject returns a HW_SSJ_ReturnObject (retObj)
// containing the menuitems for view mode displayed for every object
// retObj.mainMenuBar contains the topmost menu
//--------------------------------------------------------------------------
function HW_getMenuObject()
{
  var retObj=new HW_SSJ_ReturnObject({description:"Hyperwave Menu Creation"});
  var hwbar=new Menu("ObjMen",{menuconf:"mitemst",close:true});
  // menus needed for obj menu
  hwbar.addItem(new MenuItem(lrc("mfMenLbl61","menu","Link Map")+"...",{target:"dialogs",act:"dialog.docreferences",opobj:true,operation:"lmap"}));
  hwbar.addItem(new MenuItem(lrc("mfMenLbl65","menu","Similar Documents")+"...",{target:"dialogs",act:"dialog.similardocs",winstyle:{minWidth:740},isdisabled:place("hyper.ftserver.searchengine.name")!="verity"}));
  retObj.mainMenuBar=hwbar;
  return retObj;
}


//--------------------------------------------------------------------------
// HW_getMenuViewMode returns a HW_SSJ_ReturnObject (retObj)
// containing the menuitems for view mode
// retObj.mainMenuBar contains the topmost menu
//--------------------------------------------------------------------------
function HW_getMenuViewMode_ori()
{
  hw_menu_createStdMenuItemsViewMode();
  var curobj=request.object;
  var objiden="";
  if (!curobj.Name || curobj.Serv)
    objiden=curobj.getGOid();
  else
    objiden=curobj.Name;
  var thebase=place("gate.protocol")+"://"+place("gate.hostname_with_port")+"/"+objiden+hw_extractVersionURL();
  var retObj=new HW_SSJ_ReturnObject({description:"Hyperwave Menu Creation"});
  var hwbar=new Menu("HWMainMenu",{width:"600",menuconf:"mbarst", orientation:"top",decoration:deco,obj:thebase});

  hwbar.add(lrc("Search","hwrc","Search"),{key:"S",target:"dialogs",act:"dialog.search"});
  hwbar.add("Home",{url:"%%action.call.home%%"});
  hwbar.add(lrc("Preferences","hwrc","Preferences"),{target:"dialogs",act:"dialog.preferences",winstyle:{height:390}});
  hwbar.addDCMethodsItem({menuconf:"mitemst",decoration:deco,close:true});
  //  hwbar.addStdFunc("hwt_misc_login");
  hwbar.add(lrc("Help","hwrc","Help"),{target:"HelpWindow",act:"dialog.mainhelp.hw_bhelp"});
  hwbar.addHSpace();
  hwbar.addStdFunc("hwt_misc_authoring");
  hwbar.addStdFunc("hw_api_parents");

  retObj.mainMenuBar=hwbar;
  return retObj;
}

//--------------------------------------------------------------------------
// HW_getMenuSearchResult returns a HW_SSJ_ReturnObject (retObj)
// containing the menuitems for Search Result 
//--------------------------------------------------------------------------
function HW_getMenuSearchResult()
{
  var curobj=request.object;
  var objiden="";
  if (!curobj.Name || curobj.Serv)
    objiden=curobj.getGOid();
  else
    objiden=curobj.Name;
  var thebase=place("gate.protocol")+"://"+place("gate.hostname_with_port")+"/"+objiden+hw_extractVersionURL();
  var retObj=new HW_SSJ_ReturnObject({description:"Hyperwave Menu Creation"});
  var hwbar=new Menu("HWMainMenu",{width:"100%",menuconf:"smbstyle", orientation:"top",decoration:deco,obj:thebase});

  hwbar.add(lrc("mfMenLbl41","menu","Create Shortcut")+"...",{op:true,target:"choosetarget",act:"dialog.choosetarget",actp:"link"});
  hwbar.add(lrc("mfMenLbl42","menu","Duplicate")+"...",{op:true,target:"choosetarget",act:"dialog.choosetarget",actp:"copy"});
  if (actionhandler.componentExists("portalmaster"))
    hwbar.add(lrc("mfMenLbl64","menu","Create Bookmark")+"...",{op:true,target:"Portal_AddBookmarks",act:"dialog.portal.addbookmarks"});
  hwbar.addHSpace();
  retObj.mainMenuBar=hwbar;
  return retObj;
}

//--------------------------------------------------------------------------
// HW_getMenuExportMode returns a HW_SSJ_ReturnObject (retObj)
// containing the menuitems for export mode
// retObj.mainMenuBar contains the topmost menu
//--------------------------------------------------------------------------
function HW_getMenuExportMode()
{
  //--------------------------------------------------------------------------
  // curobj: shortcut to request.object
  //--------------------------------------------------------------------------
  var curobj=request.object;
  var objiden="";
  if (!curobj.Name || curobj.Serv)
    objiden=curobj.getGOid();
  else
    objiden=curobj.Name;
  var thebase=place("gate.protocol")+"://"+place("gate.hostname_with_port")+"/"+objiden+hw_extractVersionURL();
  var retObj=new HW_SSJ_ReturnObject({description:"Hyperwave Menu Creation"});
  var hwbar=new Menu("HWMainMenu",{width:"600",menuconf:"mbarst", orientation:"top",decoration:deco,obj:thebase});

  hwbar.add(lrc("Search","hwrc","Search"),{key:"S",exec:"call_applet(\""+place("object.get_attrib","GOid")+"\")"});
  hwbar.add("Home",{url:"/rootcollection;internal&action=home.action"});
  hwbar.add(lrc("Help","hwrc","Help"),{url:"%%action.call.help%%"});
  hwbar.addHSpace();

  var aurl="";
  if (client.EXPORT_ROOT != curobj.Name && client.EXPORT_ROOT != curobj.GOid && place("parents.count") != 0 && place("action") != "parents.action") {

    if (place("parents.count") == 1 && place("parents.next_entry")) {

      if (place("parents.entry.get_attrib","CollectionType")== "AlternativeCluster") {
        aurl="%"+"%parents.entry.call(image.action)%"+"%";
      }
      else {
        aurl="%"+"%parents.entry.uri%"+"%";
      }
    }
    else {
      aurl="%"+"%action.call(parents.action)%"+"%";
    }
    //    hwbar.add('<IMG BORDER=0 SRC="/wavemaster.internal/v1.0/uistyle/icons/oneupmenu.gif" WIDTH=15 HEIGHT=13>',{nohighlite:true,url:aurl});
  }

  retObj.mainMenuBar=hwbar;
  return retObj;
}
