// =============================================================================
// STRINGBUFFER
// =============================================================================

function hw_sb_anchor(nameAttribute) { return this.toString().anchor(nameAttribute); }

function hw_sb_append(string) {
  if (arguments[1] != undefined) {
    for (var i=0; i<arguments.length; i++)
      this.append(arguments[i]);
    return;
  }

  var i = 0, size = this._SIZE;
  while (true) {
    if (this.buffer[i].length < size)
      break;

    if (this.buffer.length-1 == i)
      this.buffer.push('');

    this.buffer[i+1] += this.buffer[i];
    this.buffer[i] = '';

    i++;
    size *= this._MULTIPLIER;
  }

  if (string == undefined)
    return;

  this.length += string.length;
  this.buffer[0] += string;
}

function hw_sb_big() { return this.toString().big(); }
function hw_sb_blink() { return this.toString().blink(); }
function hw_sb_bold() { return this.toString().bold(); }

function hw_sb_charAt(index) {
  var i = index;
  for (var b = this.buffer.length-1; b >= 0; b--) {
    var size = this.buffer[b].length;
    if (i < size)
      return this.buffer[b].charAt(i);
    i -= size;
  }
  return '';
}

function hw_sb_charCodeAt(index) {
  var i = index;
  for (var b = this.buffer.length-1; b >= 0; b--) {
    var size = this.buffer[b].length;
    if (i < size)
      return this.buffer[b].charCodeAt(i);
    i -= size;
  }
  return ''.charCodeAt();
}

function hw_sb_concat(string) {
  var sb = new StringBuffer(string);

  for (var i=1; i<arguments.length; i++)
    sb.append(arguments[i]);

  var tail = sb.toString();
  delete sb;

  return this.toString() + tail;
}

function hw_sb_fixed() { return this.toString().fixed(); }
function hw_sb_fontcolor(color) { return this.toString().fontcolor(color); }
function hw_sb_fontsize(size) { return this.toString().fontsize(size); }
function hw_sb_indexOf(searchValue, fromIndex) { return this.toString().indexOf(searchValue, fromIndex); }
function hw_sb_italics() { return this.toString().italics(); }
function hw_sb_lastIndexOf(searchValue, fromIndex) { return this.toString().lastIndexOf(searchValue, fromIndex); }
function hw_sb_link(hrefAttribute) { return this.toString().link(hrefAttribute); }
function hw_sb_match(regexp) { return this.toString().match(regexp); }
function hw_sb_replace(regexp, arg) { return this.toString().replace(regexp, arg); }
function hw_sb_search(regexp) { return this.toString().search(regexp); }

function hw_sb_set(string) {
  delete this.buffer;

  var str = string;
  if (str == undefined)
    str = '';

  this.buffer = new Array(str);
  this.length = str.length;
}

function hw_sb_slice(beginslice, endslice) { return this.toString().slice(beginslice, endslice); }
function hw_sb_small() { return this.toString().small(); }
function hw_sb_split(separator, limit) { return this.toString().split(separator, limit); }
function hw_sb_strike() { return this.toString().strike(); }
function hw_sb_sub() { return this.toString().sub(); }

function hw_sb_substr(start, length) {
  if (start >= 0) {
    if (start >= this.length)
      return '';
  }
  else {
    start += this.length;
    if (start < 0)
      start = 0;
  }

  if (length == undefined)
    length = this.length - start;

  if (length <= 0)
    return '';

  return this.substring(start, start+length);
}

function hw_sb_substring(indexA, indexB) {
  if (indexB == undefined)
    indexB = this.length;

  if (indexB < indexA) {
    var t = indexA; indexA = indexB; indexB = t;
  }

  if (indexA < 0)
    indexA = 0;

  if (indexB > this.length)
    indexB = this.length;

  if (indexA == indexB)
    return '';

  var result = '';
  for (var i=this.buffer.length-1; i>=0; i--) {
    var len = this.buffer[i].length;

    if (indexA < len)
      if (indexB <= len)
        return result + this.buffer[i].substring(indexA, indexB);
      else
        result += this.buffer[i].substring(indexA);

    indexA -= len;
    indexB -= len;
  }
}

function hw_sb_sup() { return this.toString().sup(); }
function hw_sb_toLowerCase() { return this.toString().toLowerCase(); }

function hw_sb_toString() {
  var len = this.buffer.length;

  var res = this.buffer[0];
  for (var i=1; i<len; i++)
    res = this.buffer[i] + res;

  return res;
}

function hw_sb_toUpperCase() { return this.toString().toUpperCase(); }

function StringBuffer(string, size) {
  var str = string || '';
  this.buffer = new Array(str);
  this.length = str.length;

  this._SIZE = size || 32;
  this._MULTIPLIER = 2;
}

StringBuffer.prototype.anchor      = hw_sb_anchor;
StringBuffer.prototype.append      = hw_sb_append;
StringBuffer.prototype.big         = hw_sb_big;
StringBuffer.prototype.blink       = hw_sb_blink;
StringBuffer.prototype.bold        = hw_sb_bold;
StringBuffer.prototype.charAt      = hw_sb_charAt;
StringBuffer.prototype.charCodeAt  = hw_sb_charCodeAt;
StringBuffer.prototype.concat      = hw_sb_concat;
StringBuffer.prototype.fixed       = hw_sb_fixed;
StringBuffer.prototype.fontcolor   = hw_sb_fontcolor;
StringBuffer.prototype.fontsize    = hw_sb_fontsize;
StringBuffer.prototype.indexOf     = hw_sb_indexOf;
StringBuffer.prototype.italics     = hw_sb_italics;
StringBuffer.prototype.lastIndexOf = hw_sb_lastIndexOf;
StringBuffer.prototype.link        = hw_sb_link;
StringBuffer.prototype.match       = hw_sb_match;
StringBuffer.prototype.replace     = hw_sb_replace;
StringBuffer.prototype.search      = hw_sb_search;
StringBuffer.prototype.set         = hw_sb_set;
StringBuffer.prototype.slice       = hw_sb_slice;
StringBuffer.prototype.small       = hw_sb_small;
StringBuffer.prototype.split       = hw_sb_split;
StringBuffer.prototype.strike      = hw_sb_strike;
StringBuffer.prototype.sub         = hw_sb_sub;
StringBuffer.prototype.substr      = hw_sb_substr;
StringBuffer.prototype.substring   = hw_sb_substring;
StringBuffer.prototype.sup         = hw_sb_sup;
StringBuffer.prototype.toLowerCase = hw_sb_toLowerCase;
StringBuffer.prototype.toString    = hw_sb_toString;
StringBuffer.prototype.toUpperCase = hw_sb_toUpperCase;
StringBuffer.prototype.toString    = hw_sb_toString;
